package no.uio.ifi.rcos.algebraic.createmodel

import org.scalatest.matchers.ShouldMatchers
import org.scalatest.FlatSpec
import org.scalatest.BeforeAndAfter
import no.uio.ifi.rcos.algebraic.spec.CreateModel
import edu.unu.iist.rcos.spec.antlr.MyRCOSModel

class AirportModelTest extends FlatSpec with ShouldMatchers with BeforeAndAfter{

  val fileName = "testcases/airport/airport.rcosp"

  "Creating a model of the airport" should "work" in {
    val createModel = new CreateModel
    createModel.createModelFromFileSpec("airport.uml", "airport", new MyRCOSModel.RCOSFromFile(fileName))
    createModel.model.save
  }
}