package no.uio.ifi.rcos.algebraic.createmodel

import no.uio.ifi.rcos.algebraic.spec.CreateModel
import edu.unu.iist.rcos.spec.antlr.MyRCOSModel.RCOSFromFile
import edu.unu.iist.rcos.spec.antlr.MyRCOSModel
import org.scalatest.FlatSpec
import org.scalatest.matchers.ShouldMatchers

class CreateModelFromFileTest extends FlatSpec with ShouldMatchers {
	
  "Creating a model of simple.rcosp" should "result in one component called C" in {
    val fileName = "testcases/modelcreator/simple.rcosp"
    val modelName = "TestModel.uml"
    
    val createModel = new CreateModel
    createModel.createModelFromFileSpec("test.uml", "test model", new MyRCOSModel.RCOSFromFile(fileName))
    createModel.model.getComponent("C", null, null) should not be (null)
  }
  
  "Creating a model of simple.rcosp" should "result in one interface called A" in {
    val fileName = "testcases/modelcreator/simple.rcosp"
    val modelName = "TestModel.uml"
    
    val createModel = new CreateModel
    createModel.createModelFromFileSpec("test.uml", "test model", new MyRCOSModel.RCOSFromFile(fileName))
    createModel.model.getInterface("A", null, null) should not be (null)
  }

  "Creating a model of simple.rcosp" should "result in one class called Cl" in {
    val fileName = "testcases/modelcreator/simple.rcosp"
    val modelName = "TestModel.uml"
    
    val createModel = new CreateModel
    createModel.createModelFromFileSpec("test.uml", "test model", new MyRCOSModel.RCOSFromFile(fileName))
    createModel.model.getClass("Cl", null, null) should not be (null)
  }

  "Creating a model of simple.rcosp" should "result in one process called P" in {
    val fileName = "testcases/modelcreator/simple.rcosp"
    val modelName = "TestModel.uml"
    
    val createModel = new CreateModel
    createModel.createModelFromFileSpec("test.uml", "test model", new MyRCOSModel.RCOSFromFile(fileName))
    createModel.model.getComponent("P", null, null) should not be (null)
    createModel should not be (null)
  }
  
}