package no.uio.ifi.rcos.algebraic.createmodel

import org.scalatest.FlatSpec
import org.scalatest.matchers.ShouldMatchers
import no.uio.ifi.rcos.algebraic.spec.CreateModel
import edu.unu.iist.rcos.spec.antlr.MyRCOSModel

class DisjointCompositionTests extends FlatSpec with ShouldMatchers {

  "A disjoint composition " should "behave correctly" in {
    val prog = "interface A { public foobar(); public bard();}" +
    			"interface B {public foo(); public bar(); public barbar();}" +
    			"interface F {public food();}"+
    			"component CA {provided F {public food(){}} required A;}" +
    			"component CB {required B;}" +
    			"CACB = CA o CB;"
    var createModel = new CreateModel
    createModel.createModelFromFileSpec("disjoint.uml", "disjoint", new MyRCOSModel.RCOSFromString(prog))
    createModel.model.save
  }
}