package no.uio.ifi.rcos.algebraic.createmodel

import org.scalatest.FlatSpec
import org.scalatest.matchers.ShouldMatchers
import no.uio.ifi.rcos.algebraic.spec.CreateModel
import edu.unu.iist.rcos.spec.antlr.MyRCOSModel

class BufferTests extends FlatSpec with ShouldMatchers {

   "Creating a model of TwoPlaceBuffer.rcosp" should "create all basic interfaces" in {
    val fileName = "testcases/buffer_examples/TwoPlaceBuffer.rcosp"
    val modelName = "TwoPlaceBuffer.uml"
    
    val createModel = new CreateModel
    createModel.createModelFromFileSpec("TwoPlaceBuffer.uml", "TwoPlaceBuffer", new MyRCOSModel.RCOSFromFile(fileName))
    createModel.model.getInterface("MemoryIF", null, null) should not be (null)
    createModel.model.getInterface("BuffIF", null, null) should not be (null)
    createModel.model.getInterface("IShift", null, null) should not be (null)
  }

   "Creating a model of TwoPlaceBuffer.rcosp" should "create all basic components" in {
    val fileName = "testcases/buffer_examples/TwoPlaceBuffer.rcosp"
    val modelName = "TwoPlaceBuffer.uml"
    
    val createModel = new CreateModel
    createModel.createModelFromFileSpec("test.uml", "test model", new MyRCOSModel.RCOSFromFile(fileName))
    createModel.model.getComponent("Memory", null, null) should not be (null)
    createModel.model.getComponent("Buff", null, null) should not be (null)
    createModel.model.getComponent("Shift", null, null) should not be (null)
  }
}