package no.uio.ifi.rcos.algebraic.extractors

import org.eclipse.uml2.uml.Classifier
import scala.collection.JavaConversions._
import edu.unu.iist.rcos.spec.antlr.MyRCOSModel

trait CopyAttributes {
 /**
   * copy attributes from one classifier to another
   * @author martinhb
   */
  def extractAndCopyAttributes(from : Classifier , to : Classifier, model: MyRCOSModel) {

    val fields = from.getAllAttributes()
    val associations = from.getAssociations()
    for	(field <- fields) {
       model addField(field.getName, field.getType, field.getVisibility(), to, null, null)
    }

    //Skip associations for now - haven't found a good way to handle them
    //TODO: find a better way
    for	(association <- associations) {
      for (a <- association.getNavigableOwnedEnds()) {
       model addField(a.getName(),
           association.getEndTypes().get(0), association.getVisibility(),
           to, null, null)
      }
    }
  }
}