package no.uio.ifi.rcos.algebraic.parser

import org.scalatest.FlatSpec
import org.scalatest.matchers.ShouldMatchers
import org.antlr.runtime.CharStream
import org.antlr.runtime.CommonTokenStream
import org.antlr.runtime.ANTLRFileStream
import scala.collection.JavaConversions._

class ValidRcospTestSuite extends FlatSpec with ShouldMatchers {

  var input: CharStream = _
  var lexer: new_rcospLexer = _
  var parser: new_rcospParser = _
  var tokens: CommonTokenStream = _

  "Every inputfile in src/resources/testcases/grammar" should "parse flawlessly" in {
    // Loop over every inputfile and parse them
    val dir = "testcases/grammar/valid"
    val files = new java.io.File(dir).listFiles.filter(_.getName.endsWith(".rcosp"))
    var errorsExist = false

    for (file <- files) {

      try {
        //Parse
        input = new ANTLRFileStream(file.getPath, "utf8")
        lexer = new new_rcospLexer(input)
        tokens = new CommonTokenStream(lexer)
        parser = new new_rcospParser(tokens)
        parser.rCOSSpec //Start parse
      }

      //nvm this ugly code. Its not meant for the public anyway...
      catch {
          case e : org.antlr.runtime.MismatchedTokenException => // expression
          case e : org.antlr.runtime.NoViableAltException => //exception
        }

      //Check for errors
      val parserErrors = parser.getErrors()
      if (parserErrors.size > 0) {
        parserErrors map ((x:String) => println(x))
        errorsExist = true
      }
    }
  assert(errorsExist == false)
  }
}
