package no.uio.ifi.rcos.algebraic.utility

import no.uio.ifi.rcos.algebraic.spec.CreateModel
import edu.unu.iist.rcos.spec.antlr.MyRCOSModel
import scala.swing.FileChooser
import org.antlr.runtime.CharStream
import org.antlr.runtime.ANTLRInputStream

object Main {

  def main(args: Array[String]): Unit = {
    if (args.length < 2) {
      println("To create a model from file, specify modelname and filepath as arguments")
      manualInput()
    }
    else {
      val fileName = args(1)
      if (fileName.substring(fileName.lastIndexOf(".")+1) != "rcosp") {
        println("Not an rcosp file")
        System.exit(0)
      }

      val modelName = args(0)
      //val modelName = fileName.substring(0, fileName.lastIndexOf("."))
	  val createModel = new CreateModel
      println("Creating model")
      createModel.createModelFromFileSpec(modelName+".uml", modelName, new MyRCOSModel.RCOSFromFile(fileName))
      println("Saving model")
      createModel.model.save  
      println("Done")
    }
  }
  
  def manualInput() {
    println("Manual input mode")
    println("Model name: ")
    val modelName = Console.readLine
    
    println("Program ")
	val createModel = new CreateModel
	var charStream : ANTLRInputStream = null
	charStream = new ANTLRInputStream(System.in)

    println("Creating model")

    try {
      createModel.createModelFromFileSpec(modelName+".uml", modelName, charStream)
    } catch {
      case rte: RuntimeException => println(rte.getMessage()); System.exit(1)
    }

    println("Saving model")
    createModel.model.save  
    println("Done")
  }
}
