package no.uio.ifi.rcos.algebraic.utility

import org.antlr.runtime.CharStream
import org.antlr.runtime.ANTLRInputStream
import org.antlr.runtime.ANTLRFileStream
import no.uio.ifi.rcos.algebraic.utility.PrettyASTformatter

/**
 * Run this to manually inspect(in console) the AST produced by the new_rcosp.g grammar
 * Either specify file or enter a rCOSP spec in the interpreter
 * @author martinhb
 */

object ManualASTInspection {

  def main(args: Array[String]): Unit = {
		  
    var charStream : CharStream = null
    if (args.length == 0) {
      println("Give me some input to parse")
      charStream = new ANTLRInputStream(System.in)
      println(PrettyASTformatter.prettyFormatCommonTree(charStream))
    }
  
    else {
      for (inputFile <- args) {
    	charStream = new ANTLRFileStream(inputFile)
    	println(PrettyASTformatter.prettyFormatCommonTree(charStream))
      }
    }
  }
}