package no.uio.ifi.rcos.algebraic.utility

import org.eclipse.uml2.uml.Operation
import scala.collection.JavaConversions._

/**
 * Trait for comparing two UML operations
 * @author martinhb
 */
trait OperationComparator {

  def equalOperations(first: Operation, second:Operation) : Boolean = {

    if (first.getName != second.getName)
      return false

    val firstParams = first getOwnedParameters
    val secondParams = second getOwnedParameters

    if (firstParams.size != secondParams.size)
      return false
    
    val paramTuples = firstParams zip secondParams

    //param name, type, direction
    paramTuples.forall(tuple =>
        tuple._1.getName == tuple._2.getName 
        && tuple._1.getType.getName == tuple._2.getType.getName
        && tuple._1.getDirection == tuple._2.getDirection)
  }
}
