package no.uio.ifi.rcos.algebraic.utility

import no.uio.ifi.rcos.algebraic.parser.new_rcospParser
import no.uio.ifi.rcos.algebraic.parser.new_rcospLexer
import org.antlr.runtime.ANTLRStringStream;
import org.antlr.runtime.CharStream;
import org.antlr.runtime.CommonTokenStream;
import org.antlr.runtime.RecognitionException;
import org.antlr.runtime.tree.CommonTree;
import org.antlr.runtime.tree.CommonTreeNodeStream;

/**
 * Utility class for common parsing operations
 * @author martinhb
 */
object Parse {

  private def parse(charStream : CharStream) : new_rcospParser = {
    val lexer = new new_rcospLexer(charStream)
    val tokens = new CommonTokenStream(lexer)
    new new_rcospParser(tokens)
  }
  
  def getCommonTree(charStream : CharStream ) : CommonTree = {
		val parser : new_rcospParser = parse(charStream)
		(parser.rCOSSpec().getTree()).asInstanceOf[CommonTree]
	}
}