package no.uio.ifi.rcos.algebraic.utility

import org.antlr.runtime.CharStream
import org.antlr.runtime.tree.CommonTree
import scala.collection.mutable.StringBuilder

object PrettyASTformatter {

  /**
   * Small function to format the single line returned from toStringTree in CommonTree
   * @author martinhb
   */
  def prettyFormatCommonTree(charStream : CharStream) : String = {
    val tree : CommonTree = Parse getCommonTree charStream
    val sb = new StringBuilder
    var indentLevel = 0
    for (c <- tree.toStringTree()) {
      c match {
        case '(' => indentLevel += 1; sb.append("\n"+" "*indentLevel+"(")
        case ')' => indentLevel -= 1; sb.append(c)
        case _ => sb.append(c)
      }
    }
    sb.toString
  }
}