package edu.unu.iist.rcos.modeler.translation.test;

import static org.junit.Assert.*;
import edu.unu.iist.rcos.modeler.translation.*;
import edu.unu.iist.rcos.uml.RCOSLoader;
import org.junit.Test;

/**
 * @author vs
 * Some UML export tests
 */
public class TestUMLTranslation {
	
	@Test
	public void test_toRCOSP_base() throws Exception {
		RCOSLoader rl = new RCOSLoader("../examples/CoCoME/cocome/CoCoME.uml");
		RCOSpecTranslation rst = new RCOSpecTranslation();
		String out = rst.translate(rl.rcos);
		assertTrue("No output!", out.length() > 0);
	}
	
	@Test(expected=ExportException.class)
	public void test_toRCOSP_1() throws Exception {
		// The input is not really an rCOS requirements model since it has sub-packages inside the ClassModel.
		RCOSLoader rl = new RCOSLoader("testcases/expert/ExpertTest.uml");
		RCOSpecTranslation rst = new ValidatedRCOSSpecTranslation();
		String out = rst.translate(rl.rcos);
		System.err.println(out);
		assertTrue("No output!", out.length() > 0);
	}
	
	@Test(expected=ExportException.class)
	public void test_toRCOSP_packages_collide() throws Exception {
		// The input is not really an rCOS requirements model since it has sub-packages inside the ClassModel.
		// There are (at least) two package with class A.
		RCOSLoader rl = new RCOSLoader("testcases/tc/Tests.uml");
		RCOSpecTranslation rst = new ValidatedRCOSSpecTranslation();
		rst.translate(rl.rcos);
	}

	@Test
	public void test_Library() throws Exception {
		RCOSLoader rl = new RCOSLoader("../examples/Library/LibModel.uml");
		RCOSpecTranslation rst = new ValidatedRCOSSpecTranslation();
		rst.translate(rl.rcos);
	}
}
