package edu.unu.iist.rcos.modeler.translation.test;

import static org.junit.Assert.*;

import org.eclipse.uml2.uml.Association;
import org.eclipse.uml2.uml.Class;
import org.eclipse.uml2.uml.NamedElement;
import org.junit.Test;

import edu.unu.iist.rcos.profile.ClassModel;
import edu.unu.iist.rcos.profile.RCOSModel;
import edu.unu.iist.rcos.uml.RCOSLoader;

public class Test_CoCoMETranslateAndParse extends TranslateAndParse {

	@Test
	public void testCoCoME() throws Exception {
		runTest("../examples/CoCoME/cocome/CoCoME.uml");
	}

	@Test
	public void testCoCoME_R() throws Exception {
		runTest("../examples/CoCoME/cocome_usecase_refinement/CoCoME.uml");
	}
	
	@Test
	public void testCoCoME_Exe() throws Exception {
		runTest("../examples/CoCoME/cocome/CoCoME-exe.uml");
	}

	@Test
	public void testCoCoME_R_Duplicate_Card() throws Exception {
		RCOSModel rm = runTest("../examples/CoCoME/cocome_usecase_refinement/CoCoME.uml");
		ClassModel cm = rm.getClassModel();
		int i = 0;
		for (NamedElement c : cm.getBase_Package().getOwnedMembers()) {
			if (c.getName().equals("Card"))
				i++;
		}
		assertTrue("Expecting one class 'Card', found "+i,i==1);
	}

	@Test
	public void testCoCoME_Assocs_lost() throws Exception {
		RCOSLoader r = new RCOSLoader("../examples/CoCoME/cocome/CoCoME.uml");
		Class c = (Class)r.rcos.getClassModel().getBase_Package().getOwnedMember("Cashdesk");
		
		// establish that input is okay:
		assertNull(c.getOwnedAttribute("line", null));
		boolean foundLineitem = false;
		for (Association d : c.getAssociations()) {
			foundLineitem |= (d.getEndType("LineItem") != null);
		}
		assertTrue(foundLineitem);
		
		RCOSModel m = runTest("../examples/CoCoME/cocome/CoCoME.uml");
		c = (Class)m.getClassModel().getBase_Package().getOwnedMember("Cashdesk");
		assertNull("Association 'line' got converted into an attribute!",c.getOwnedAttribute("line", null));
	}
	
	@Test
	public void testCoCoME_123() throws Exception {
		runTest("../examples/CoCoME/cocome_usecase_refinement_1_2_3/CoCoME.uml");
	}
}
