package edu.unu.iist.rcos.modeler.translation.test;

import org.junit.Test;

import edu.unu.iist.rcos.modeler.translation.RCOSpecTranslation;
import edu.unu.iist.rcos.spec.antlr.MyRCOSModel;
import edu.unu.iist.rcos.spec.antlr.ParseRCOSModelTC;

public class Test_TranslateAndParse extends TranslateAndParse {

	@Test
	public void test_PrimitiveTypeParse() throws Exception {
		runTest("testcases/rCOS-models/Test_PrimitiveTypes.uml");
	}
	
	@Test
	public void TwoPlaceBuffer() throws Exception {
		MyRCOSModel rm = new ParseRCOSModelTC("2pb-1.uml","TwoPlaceBuffer", new MyRCOSModel.RCOSFromFile("../examples/OnePlaceBuffer/TwoPlaceBuffer.rcosp"));
		rm.validate();
		RCOSpecTranslation trans = new RCOSpecTranslation();
		String out = trans.translate(rm.rcos);
		System.out.println(out);
		MyRCOSModel rm2 = new ParseRCOSModelTC("2pb-2.uml","TwoPlaceBuffer", new MyRCOSModel.RCOSFromString(out));
		rm2.validate();
	}
	
	@Test
	public void TwoPlaceBuffer_UTP() throws Exception {
		final String xmi_file = "2pb-1.uml";
		final String xmi_file_out = "2pb-2.uml";
		final String model_name = "TwoPlaceBuffer";
		final String rcosp = "../examples/OnePlaceBuffer/2PB-UTP08.rcosp";
		loadAndCheck(xmi_file, xmi_file_out, model_name, rcosp);
	}

	private void loadAndCheck(final String xmi_file, final String xmi_file_out,
			final String model_name, final String rcosp)
			throws Exception {
		MyRCOSModel rm = new ParseRCOSModelTC(xmi_file,model_name, new MyRCOSModel.RCOSFromFile(rcosp));
		rm.validate();
		RCOSpecTranslation trans = new RCOSpecTranslation();
		String out = trans.translate(rm.rcos);
		System.out.println(out);
		MyRCOSModel rm2 = new ParseRCOSModelTC(xmi_file_out,model_name, new MyRCOSModel.RCOSFromString(out));
		rm2.validate();
	}

	@Test
	public void test_Library() throws Exception {
		runTest("../examples/Library/LibModel.uml");
	}
}
