package edu.unu.iist.rcos.modeler.translation.test;

import edu.unu.iist.rcos.modeler.translation.*;
import edu.unu.iist.rcos.profile.RCOSModel;
import edu.unu.iist.rcos.spec.antlr.MyRCOSModel;
import edu.unu.iist.rcos.spec.antlr.MyRCOSModel.RCOSFromString;
import edu.unu.iist.rcos.uml.RCOSLoader;

public class TranslateAndParse {
	
	protected String filename="scratch-TranslateAndParse.uml";

	RCOSModel runTest(String model) throws Exception {
		return runTest(model,false);
	}
	
	RCOSModel runTest(String model, boolean incomplete) throws Exception {
		RCOSLoader r = new RCOSLoader(model);
		Translation tran = new RCOSpecTranslation();
		String buf = tran.translate(r.rcos);
		System.err.println(buf);
		MyRCOSModel m = new MyRCOSModel(filename, "test", new RCOSFromString(buf), incomplete);
		m.save();
		m.validate();
		
		return m.rcos;
	}
}
