package edu.unu.iist.rcos.spec.antlr;

import java.util.ArrayList;
import java.util.List;

import org.antlr.runtime.RecognitionException;
import org.junit.Test;

import edu.unu.iist.rcos.mm.resources.tests.CoCoME_Loader;
import edu.unu.iist.rcos.spec.antlr.AbstractRCOSModel;
import edu.unu.iist.rcos.spec.antlr.DesignUtility;
import edu.unu.iist.rcos.spec.antlr.Parse;
import edu.unu.iist.rcos.spec.antlr.SyntaxTree.SyntaxTree_ClassModel.*;
import static edu.unu.iist.rcos.spec.antlr.DesignUtility.*;
import static org.junit.Assert.*;

public class Test_DesignExpression extends CoCoME_Loader {
	@Test
	public void testExpParsing() throws RecognitionException{
		
		List<String> l	= new ArrayList<String>(20);
		l.add("x");
		l.add("m()");
		l.add("x.m()");
		l.add("x.y.z");
		l.add("1");
		l.add("n(1)");
		l.add("m()");
		l.add("A.x");
		l.add("B.m()");
		l.add("A.n(x).n()");
		l.add("this.n(x).n()");
		l.add("n(x).n(x)");
		l.add("n().z");
		l.add("this.x");
		l.add("this.m()");
		l.add("this.x.m()");
		l.add("this.m().x");
		l.add("this.x.z.m().y");
		l.add("A.new()");
		l.add("super.m()");
//		
		System.out.println("\n********************************** Start of parsing exp ***************************************\n");
		for (String e : l){
			System.out.println("The Tree of \"" + e + "\" is : " + Parse.getCommonTreeOfExpFromString(e).toStringTree());
		}
		System.out.println("\n********************************** End of parsing exp ***************************************\n");
	}
	
	@Test
	public void testDesignParsing() throws RecognitionException{
		
		List<String> l	= new ArrayList<String>(20);
		l.add("skip ; skip ; skip ; skip ; skip ; skip ; skip ; skip ; skip ; skip ; skip ; skip ; skip ; skip ; skip ; skip ; skip ; skip ; skip ; skip ; skip ; skip ; skip ; skip ; skip ; skip ; skip ; skip ; skip ; skip ; skip ; skip ; skip ; skip ; skip ; skip ; skip ; skip ; skip ; skip ; skip ; skip ; skip ; skip ; skip ; skip ; skip ; skip ; skip ; skip ; skip ; skip ; skip ; skip ; skip ; skip ; skip ; skip ; skip ; skip ; skip ; skip ; skip ; skip ; skip ; skip ; skip ; skip ; skip ; skip ; skip");
		l.add("quantity := 2");
		l.add("var C x; x := 2");
		l.add("x:= x; y := 2; x:= 2");
		l.add("x := y");
		l.add("if (b) then {x := 3} else {y := 4}");
		l.add("while (b) {x := 3; x := y}");
		l.add("x:= 2 \\/ x := y");
		l.add("m(a, b; x, y)");
		l.add("m(c', d; x, y)");
		l.add("m(e', f'; x, y)");
		l.add("super.m(e', f'; x, y)");
		l.add("skip");
		l.add("n()");
		l.add("skip; x:= 2");
		l.add("[ x' = 2 |- x' = y AND x' = 3]");
		l.add("skip; return 2");
		l.add("[\\exist Item i : store.catalog.contains(i) && i.barcode = code && qty > 0 && sale != null |-  line' = LineItem.new(code, qty) ;	\\exist Item j : store.catalog.contains(j) && j.barcode = code &&		   line.subtotal' = j.price * qty; sale.lines.add(line)]");
		l.add("var boolean b ; b := false ;  for (Item i : this.store.catalog) {if (((i.barcode = code) AND ((qty > 0) AND (this.sale != null)))) then { b := true } else { skip } } ; if (b) then { this.line := LineItem.new(code, qty) } else { chaos }  ; end b ; var boolean b_0 ; b_0 := false ;  for (Item j : this.store.catalog) {if ((j.barcode = code)) then { b_0 := true } else { skip } } ; if (b_0) then { this.line.subtotal := (j.price * qty) } else { magic }  ; end b_0 ; if (this.sale.lines.add(this.line)) then { skip } else { magic } ");
		l.add("var boolean b_3;b_3 := false;var boolean b_5;b_5 := false;[ \\forall int x:this.finishSale()|-(b_5' = true) ];skip;[ b_5|-true ];end b_5;[ true|-(b_3' = true) ];var boolean b_4;b_4 := false;var boolean b_6;b_6 := false;[ \\exists int y:this.finishSale()|-(b_6' = true) ];skip;[ b_6|-true ];end b_6;[ true|-(b_4' = true) ];skip;if ((b_3 AND (b_4 OR this.startSale()))) then {	skip } else {	chaos };end b_4;end b_3");
		
				System.out.println("\n********************************** Start of parsing designs ***************************************\n");
		for (String e : l){
			System.out.println("The Tree of \"" + e + "\" is : " + Parse.getCommonTreeOfDesignFromString(e).toStringTree());
			Parse.getDesignFromString(e);
		}
		System.out.println("\n********************************** End of parsing designs ***************************************\n");
	}
	
	@Test
	public void testExpression() throws RecognitionException{

		EXP e1 = Parse.getExpFromString("0");
		EXP e2 = Parse.getExpFromString("true");
		EXP e3 = Parse.getExpFromString("1 + 2");
		EXP e4 = Parse.getExpFromString("x + 3");
		EXP e5 = Parse.getExpFromString("z + y");
		EXP e6 = Parse.getExpFromString("w = 5");
		EXP e7 = Parse.getExpFromString("p' = 5");
		EXP e8 = Parse.getExpFromString("m(a, b; x, y)");
		EXP e9 = Parse.getExpFromString("m(c', d; x, y)");
		EXP e10 = Parse.getExpFromString("m(e', f'; x, y)");
		EXP e11 = Parse.getExpFromString("\\forall T x : x' = 8");
		EXP e12 = Parse.getExpFromString("\\forall T x : x = 8 AND y > 9");
		EXP e13 = Parse.getExpFromString("x.y' + x.z");
		EXP e14 = Parse.getExpFromString("x' = 2 AND y = 3 AND z' = 7 OR x' = 1");
		
		List<EXP> l	= new ArrayList<EXP>(20);
		l.add(e1);
		l.add(e2);
		l.add(e3);
		l.add(e4);
		l.add(e5);
		l.add(e6);
		l.add(e7);
		l.add(e8);
		l.add(e9);
		l.add(e10);
		l.add(e11);
		l.add(e12);
		l.add(e13);
		l.add(e14);
		
		System.out.println("\n********************************** Start of exp primed variables ***************************************\n");
		for (EXP e : l){
			if (hasPrimedVariables(e)){
				System.out.print("The expression \"" + expToString(e) + "\" has the primed variable(s) : ");
				for (REF r : getPrimedVariables(e)){
					System.out.print(expToString(r) + " ");
				}
				System.out.println("");
			} else {
				System.out.println("The expression \"" + expToString(e) + "\" has no primed variable(s)");
			}
			
		}
		System.out.println("\n********************************** End of exp primed variables ***************************************\n");
	}

	
	@Test
	public void testAbstractionExpression() throws Exception{
		EXP e1 = Parse.getExpFromString("x' > 0 AND y > 0 OR x > 0");
		EXP e2 = Parse.getExpFromString("x > 0 AND x > y");
		EXP e3 = Parse.getExpFromString("x > 0 AND x > 1 + 2");
		EXP e4 = Parse.getExpFromString("x > 0 OR x > 1 +2");
		EXP e5 = Parse.getExpFromString("x + x = 3 => true");
		EXP e6 = Parse.getExpFromString("w = 5");
		EXP e7 = Parse.getExpFromString("p' = 5");
		EXP e8 = Parse.getExpFromString("m(a, b; x, y)");
		EXP e9 = Parse.getExpFromString("m(c', d; x, y)");
		EXP e10 = Parse.getExpFromString("m(e', f'; x, y)");
		EXP e11 = Parse.getExpFromString("\\forall T x : x = 8  AND y > 9");
		EXP e12 = Parse.getExpFromString("\\forall T y : x' = 8 AND y > 9");
		EXP e13 = Parse.getExpFromString("x.y' + x.z");
		EXP e14 = Parse.getExpFromString("x' = 2 AND x' = 3 AND x' = 7 AND x' = 1");
		EXP e15 = DesignUtility.copyExpression(e8);
		
		List<EXP> l	= new ArrayList<EXP>(20);
		l.add(e1);
		l.add(e2);
		l.add(e3);
		l.add(e4);
		l.add(e5);
		l.add(e6);
		l.add(e7);
		l.add(e8);
		l.add(e9);
		l.add(e10);
		l.add(e11);
		l.add(e12);
		l.add(e13);
		l.add(e14);
		l.add(e15);
		
		List<String> lfa = new ArrayList<String>();
		lfa.add("x");
		System.out.println("\n********************************** Start of exp abstraction ***************************************\n");
		for (EXP e : l){
			System.out.println("The exp : '" + expToString(e) + "' is abstracted in '" +
					expToString(AbstractRCOSModel.abstractExp(e, lfa, null)) + "'");
			
		}
		System.out.println("\n********************************** End of exp abstraction ***************************************\n");
	}

	@Test
	public void test_abstraction() throws Exception {
		List<String> lfa = new ArrayList<String>();
		lfa.add("exmode");
		final String input = "this.exmode'";
		EXP e = Parse.getExpFromString(input);
		final String output = expToString(AbstractRCOSModel.abstractExp(e, lfa, null));
		System.out.println("The exp : '" + expToString(e) + "' is abstracted in '" +
				output + "'");
		assertEquals(input,output);
	}

	@Test
	public void test_getIds() throws Exception {
		EXP e = Parse.getExpFromString("x AND exists Object y: true");
		assertFalse(DesignUtility.getListId(e).contains("y"));
		assertTrue(DesignUtility.getListId(e).contains("this.x"));
	}

	@Test
	public void testAbstractionDesign() throws Exception{
		System.out.println("\n********************************** Start of design abstraction ***************************************\n");
		DESIGN e1 = Parse.getDesignFromString("b := 2");
		DESIGN e2 = Parse.getDesignFromString("var int x; x := 2");
		DESIGN e3 = Parse.getDesignFromString("x:= x; y := 2; x:= 2");
		DESIGN e4 = Parse.getDesignFromString("x := y");
		DESIGN e5 = Parse.getDesignFromString("if (b) then {x := 3} else {y := 4}");
		DESIGN e6 = Parse.getDesignFromString("while (b) {x := 3; x := y}");
		DESIGN e7 = Parse.getDesignFromString("x:= 2 \\/ x := y");
		DESIGN e8 = Parse.getDesignFromString("m(a, b; x, y)");
		DESIGN e9 = Parse.getDesignFromString("m(c', d; x, y)");
		DESIGN e10 = Parse.getDesignFromString("m(e', f'; x, y)");
		DESIGN e11 = Parse.getDesignFromString("skip");
		DESIGN e12 = Parse.getDesignFromString("chaos");
		DESIGN e13 = Parse.getDesignFromString("skip; x:= 2");
		DESIGN e14 = Parse.getDesignFromString("[ x' = 2 |- x' = y AND x' = 3]");
		DESIGN e15 = Parse.getDesignFromString("if (true) then {x := 3} else {y := 4}");
		
		List<DESIGN> l	= new ArrayList<DESIGN>(20);
		l.add(e1);
		l.add(e2);
		l.add(e3);
		l.add(e4);
		l.add(e5);
		l.add(e6);
		l.add(e7);
		l.add(e8);
		l.add(e9);
		l.add(e10);
		l.add(e11);
		l.add(e12);
		l.add(e13);
		l.add(e14);
		l.add(e15);
		
		List<String> lfa = new ArrayList<String>();
		lfa.add("x");
	
		for (DESIGN e : l){
			System.out.println("The design : '" + designToString(e) + "' is abstracted in '" +
					designToString(AbstractRCOSModel.abstractDesign(e, lfa, null)) + "'");
			
		}
		System.out.println("\n********************************** End of design abstraction ***************************************\n");
	}

	@Test
	public void testRewriteDesign() throws Exception{
		
		List<DESIGN> l	= new ArrayList<DESIGN>(20);

		l.add(Parse.getDesignFromString("[ true |- (2 = 2) => (3 = 3) => x'= 3 ] ; [(4 = 4) |- y' = 5]"));
		l.add(Parse.getDesignFromString("[ true |- (\\forall int x : x > 1) => (3 = 3) => x'= 3 ] ; [(4 = 4) |- y' = 5]"));
		l.add(Parse.getDesignFromString("[ x > 2 |- false ]"));
//		l.add(Parse.getDesignFromString("[ x > 2 |- \\forall Item x : store.catalog.contains(x) => (y'=x + 2 AND foo(x))]"));
		l.add(Parse.getDesignFromString("[ x > 2 |- finishSale() ]"));
		l.add(Parse.getDesignFromString("[\\forall Item  x : store.catalog.contains(x) => x > 3 |- finishSale()]"));
		l.add(Parse.getDesignFromString("[\\exist Item x : store.catalog.contains(x) AND \\exists Item y : store.catalog.contains(y) AND p(x,y) |- finishSale() ]"));
		l.add(Parse.getDesignFromString("var boolean b ; [\\exist Item i : store.catalog.contains(i) && i.barcode = code && qty > 0 && sale != null |-  " +
				"line' = LineItem.new(code, qty) ; " +
				"\\exist Item j : store.catalog.contains(j) && j.barcode = code && " +
				" line.subtotal' = j.price * qty; sale.lines.add(line)]"));
		l.add(Parse.getDesignFromString("[\\exist Item i : store.catalog.contains(i) && i.barcode = code && qty > 0 && sale != null |-  " +
				"line' = LineItem.new(code, qty) ; " +
				"\\exist Item j : store.catalog.contains(j) && j.barcode = code && " +
				" line.subtotal' = j.price * qty; sale.lines.add(line)]"));
		l.add(Parse.getDesignFromString("[ sale != null && bank.authorize(c, sale.total) |- sale.pay' = CardPayment.new(c); store.sales.add(sale); \\forall LineItem l: sale.lines.contains(l) => \\forall Item p : store.catalog.contains(p) => (p.barcode = l.barcode) => p.stock' = p.stock - l.quantity ]"));
		l.add(Parse.getDesignFromString("[|- \\exist Item j : store.catalog.contains(j) && j.barcode = code && " +
				" line.subtotal' = j.price * qty; sale.lines.add(line)]"));
		l.add(Parse.getDesignFromString("[|- \\forall Item j : store.catalog.contains(j) => (j.barcode = code && " +
		" line.subtotal' = j.price * qty); sale.lines.add(line)]"));
		l.add(Parse.getDesignFromString("[|- \\forall Item j : store.catalog.contains(j) => (j.barcode = code => " +
		" line.subtotal' = j.price * qty); sale.lines.add(line)]"));
		
		System.out.println("\n********************************** Start of design rewriting ***************************************\n");
		
		for (DESIGN e : l){
			String new_des = designToString(refine(e, cashdesk));
			System.out.print("The design : '" + designToString(e) + "' is rewrited to  \n'" +
					new_des + "'");
			System.err.println(Parse.getDesignFromString(new_des)!=null?" ok":" not ok");
			
		}
		
		System.out.println("\n********************************** End of design rewriting ***************************************\n");
	}
	
	
	@Test
	public void testAbsSetOpsDesign() throws Exception{
		DESIGN e1 = Parse.getDesignFromString("x := 2");
		DESIGN e2 = Parse.getDesignFromString("var int x; x := 2");
		DESIGN e3 = Parse.getDesignFromString("x:= x + 1; y := 2; x:= 2");
		DESIGN e4 = Parse.getDesignFromString("x := 2");
		DESIGN e5 = Parse.getDesignFromString("if (b) then {x := 3} else {y := 4}");
		DESIGN e6 = Parse.getDesignFromString("while (b) {x := 3; x := y}");
		DESIGN e7 = Parse.getDesignFromString("x:= 2 \\/ x := y");
		DESIGN e8 = Parse.getDesignFromString("m(a, b; x, y)");
		DESIGN e9 = Parse.getDesignFromString("m(c', d; x, y)");
		DESIGN e10 = Parse.getDesignFromString("m.add(e', f'; x, y)");
		DESIGN e11 = Parse.getDesignFromString("for (T x : e) { x := 2 } ");
		DESIGN e12 = Parse.getDesignFromString("[ |- x.y' = 2]");
		DESIGN e13 = Parse.getDesignFromString("[ store.catalog.find(code) != null |- line' = LineItem.new(code, qty) ; line.subtotal' = store.catalog.find(code).price * qty; sale.lines.add(line)]");
		DESIGN e14 = Parse.getDesignFromString("[ x' = 2 |- x' = y AND x' = toto.add()]");
		
		List<DESIGN> l	= new ArrayList<DESIGN>(20);
		l.add(e1);
		l.add(e2);
		l.add(e3);
		l.add(e4);
		l.add(e5);
		l.add(e6);
		l.add(e7);
		l.add(e8);
		l.add(e9);
		l.add(e10);
		l.add(e11);
		l.add(e12);
		l.add(e13);
		l.add(e14);
		
		System.out.println("\n********************************** Start of set-abstraction ***************************************\n");
		
		for (DESIGN e : l){
			System.out.println("The design : '" + designToString(e) + "' is set-abstracted  to  '" +
					designToString(abstractSetOpsDesign(e)) + "'");
			
		}
		
		System.out.println("\n********************************** End of set-abstraction ***************************************\n");
	}

	@Test
	public void test_broken_AbstractSetOps1() throws Exception {
		DESIGN d = Parse.getDesignFromString("[ |-(this.x.y' = 2) ]");
		DESIGN dOut = DesignUtility.abstractSetOpsDesign(d);
		assertTrue(DesignUtility.isDesignEqual(d, dOut));
	}
}
