package edu.unu.iist.rcos.spec.antlr;

import static org.junit.Assert.*;
import org.eclipse.emf.common.command.Command;
import org.eclipse.uml2.uml.Operation;
import org.junit.Test;

import edu.unu.iist.rcos.mm.resources.tests.CoCoME_Loader;
import edu.unu.iist.rcos.spec.antlr.RCOSModelUtility;
import edu.unu.iist.rcos.spec.antlr.RCOSModelValidation;
import edu.unu.iist.rcos.spec.antlr.SyntaxTree.SyntaxTree_ClassModel.DESIGN;
import edu.unu.iist.rcos.spec.antlr.SyntaxTree.SyntaxTree_ClassModel.PP;
import edu.unu.iist.rcos.spec.transformer.DesignTransformerRewrite;

public class Test_Rewrite extends CoCoME_Loader {

	@Test
	public void test_rewrite() throws Exception {
		new RCOSModelValidation().validate(rcos);
		DesignTransformerRewrite dtep = new DesignTransformerRewrite(editingDomain);
		Command command = RCOSModelUtility.transformAllClasses(editingDomain,rcos,dtep);
		checkErrors(command);

		Operation ei = cashdesk.getOwnedOperation("enterItem", null, null);
		assertNotNull(ei);
		DESIGN d = Parse.getDesign(ei);
		assertTrue("The design of enterItem is still a pre-post ", ! (d instanceof PP));

		new RCOSModelValidation().validate(rcos);
	}

}
