package edu.unu.iist.rcos.spec.antlr;

import org.antlr.runtime.RecognitionException;
import org.junit.*;

import edu.unu.iist.rcos.mm.resources.tests.CoCoME_Loader;
import edu.unu.iist.rcos.spec.tc.*;
import edu.unu.iist.rcos.spec.tc.RuleTCMembersED.*;

/**
 * @author stolz
 * More heavy-weight tests that base on the CoCoME loader (but don't check CoCoME themselves).
 */
public class Test_TC2 extends CoCoME_Loader {

	RuleTCMembersED rtc;
	
	@Test(expected=RecognitionException.class)
	public void test_broken_EXP_from_UML() throws Exception {
		RuleClassInvariant rule = rtc.new RuleClassInvariant();
		rule.check(cashdesk, "store != null AND ca talog != null");
	}
	
	@Test(expected=RecognitionException.class)
	public void test_broken_EXP_from_UML_guard() throws Exception {
		RuleOperationGuard rule = rtc.new RuleOperationGuard();
		rule.check(cashdesk.getOperation("startSale", null, null), "store != null AND ca talog != null");
	}
	
	@Test(expected=edu.unu.iist.rcos.mm.util.TypingException.class)
	public void test_Number_is_Bool() throws Exception {
		RuleClassInvariant rule = rtc.new RuleClassInvariant();
		rule.check(cashdesk, "5");		
	}

	@Before
	public void setup() throws Exception {
		super.setup();
		rtc = new RuleTCMembersED(editingDomain);
	}
	
	@Override
	public void teardown() {
		super.teardown();
		rtc = null;
	}
}
