package edu.unu.iist.rcos.spec.antlr;

import static org.junit.Assert.*;

import org.eclipse.emf.common.command.Command;
import org.junit.Test;

import edu.unu.iist.rcos.mm.resources.tests.CoCoME_Loader;
import edu.unu.iist.rcos.modeler.translation.RCOSpecTranslation;
import edu.unu.iist.rcos.spec.antlr.visitor.toUTF8.UTF8Converter;

// TODO: could actually run with many (parametrized) models
public class Test_UTF8Converter extends CoCoME_Loader {

	@Test
	public void test_utf8_validate() throws Exception {
		Command cmd;
		editingDomain.getCommandStack().execute(cmd = new UTF8Converter(editingDomain,rcos).toUTF8());
		assertTrue(cmd.canExecute());
		assertTrue(new RCOSModelValidation().validate(rcos));
	}

	@Test
	public void test_utf8_validate_and_parse() throws Exception {
		Command cmd;
		editingDomain.getCommandStack().execute(cmd = new UTF8Converter(editingDomain,rcos).toUTF8());
		assertTrue(cmd.canExecute());
		assertTrue(new RCOSModelValidation().validate(rcos));
		RCOSpecTranslation trans = new RCOSpecTranslation();
		String out = trans.translate(rcos);
		System.out.println(out);
		MyRCOSModel rm2 = new ParseRCOSModelTC("CoCoME-utf8.uml","CoCoME-utf8", new MyRCOSModel.RCOSFromString(out));
		rm2.validate();
	}

}
