package edu.unu.iist.rcos.spec.antlr;

import java.util.ArrayList;
import java.util.List;

import org.antlr.runtime.RecognitionException;
import org.eclipse.emf.common.util.URI;
import org.eclipse.uml2.uml.Class;
import org.eclipse.uml2.uml.Operation;
import org.junit.Test;

import edu.unu.iist.rcos.mm.resources.tests.CoCoME_Loader;
import edu.unu.iist.rcos.profile.RCOSModel;
import edu.unu.iist.rcos.spec.antlr.DesignUtility;
import edu.unu.iist.rcos.spec.antlr.Parse;
import edu.unu.iist.rcos.uml.NotAnRCOSModelException;
import edu.unu.iist.rcos.uml.RCOSLoader;

public class Test_getType extends CoCoME_Loader {

	public void testDesign() throws RecognitionException{
		
		List<String> l	= new ArrayList<String>(20);
		l.add("quantity := 2");
		l.add("var C x; x := 2");
		l.add("x:= x; y := 2; x:= 2");
		l.add("x := y");
		l.add("if (b) then {x := 3} else {y := 4}");
		l.add("while (b) {x := 3; x := y}");
		l.add("x:= 2 \\/ x := y");
		l.add("m(a, b; x, y)");
		l.add("m(c', d; x, y)");
		l.add("m(e', f'; x, y)");
		l.add("skip");
		l.add("chaos");
		l.add("skip; x:= 2");
		l.add("[ x' = 2 |- x' = y AND x' = 3]");
		
		System.out.println("\n********************************** Start of type check ***************************************\n");
		for (String e : l){
			System.out.println("The Tree of \"" + e + "\" is : " + Parse.getCommonTreeOfDesignFromString(e).toStringTree());
		}
		System.out.println("\n********************************** End of type check ***************************************\n");
	}

	@Test
	public void testTC_testEP() throws RecognitionException, NotAnRCOSModelException{
		RCOSLoader rl = new RCOSLoader(URI.createFileURI("testcases/rCOS-models/TestEP.uml"));
		RCOSModel mod = rl.rcos;
		Class cl = (Class)mod.getClassModel().getBase_Package().getOwnedMember("D");
		Operation foo = cl.getOperation("foo", null, null);

		
		List<String> l	= new ArrayList<String>(20);
		l.add("c.b.a.f := c.b.a.f + 1");
		l.add("foo().b.a.f := 1");
		l.add("bar().b.a.f := c.b.a.f");
		l.add("bar(1).b.a.f := c.b.a.f");
		l.add("bar(1, true).b.a.f := c.b.a.f");
		l.add("c.bar().b.a.f := c.b.a.f");
		l.add("bar().a.f := c.b.a.f");
		l.add("c.b.a.f := c.b.a.f + 1; bar().b.a.f := c.b.a.f");
	
		System.out.println("\n********************************** Start of type check ***************************************\n");
		for (String e : l){
//			System.out.println(Parse.getCommonTreeOfDesignFromString(e).toStringTree());
			System.out.println("The design \"" + e + "\" is well typed: " + DesignUtility.isWellTypedDesign(Parse.getDesignFromString(e),foo));
		}
		System.out.println("\n**********************************  End of type check  ***************************************\n");
	}

	@Test
	public void testDesign2() throws RecognitionException{
				 
		Class cl = cashdesk;
		Operation foo = cl.getOperation("enterItem", null, null);
		
		List<String> l	= new ArrayList<String>(20);
		l.add("sale.lines.quantity := 2");
		l.add("var Sale s; [ |- sale' = s]");
		l.add("var LineItem s; sale := s");
		l.add("sale := 2");
		l.add(" sale.lines.quantity.toto := 1.2 ");
		l.add("var boolean b; exmode := b");
		l.add("exmode := true");
		l.add("exmode := 2");
		l.add("[ |- exmode' = true AND 2] ");
		l.add("[ |- exmode' = 2] ");
		l.add("var int x; \n" +
				"[ |- x < 1.3] ");
		l.add("[ |- 1 < 2] ");
		l.add("[ |- exmode < true ] ");
		l.add("var Barcode code; var int qty; if (store.catalog.find(code) != null) then {line := LineItem.new(code, qty) ; line.subtotal := store.catalog.find(code).price * qty; sale.lines.add(line)} else { chaos }");
		l.add("return true");
		
		System.out.println("\n********************************** Start of type check ***************************************\n");
		for (String e : l){
			System.out.println("The design \"" + e + "\" is well typed: " + DesignUtility.isWellTypedDesign(Parse.getDesignFromString(e),foo));
		}
		System.out.println("\n**********************************  End of type check  ***************************************\n");
	}
}
