package edu.unu.iist.rcos.spec.antlr.test;

import static org.junit.Assert.assertTrue;

import org.eclipse.emf.common.command.Command;
import org.junit.Before;
import org.junit.Test;

import edu.unu.iist.rcos.mm.resources.tests.CoCoME_Loader;
import edu.unu.iist.rcos.modeler.translation.RCOSpecTranslation;
import edu.unu.iist.rcos.spec.antlr.*;
import edu.unu.iist.rcos.spec.antlr.MyRCOSModel.RCOSFromString;
import edu.unu.iist.rcos.spec.antlr.commands.ExpertPatternClassCommand;
import edu.unu.iist.rcos.spec.antlr.commands.ExpertPatternOperationCommand;

public class Test_EP_CoCoME extends CoCoME_Loader {

	RCOSModelValidation rmv = new RCOSModelValidation();
	String filename = "scratch-ep-cocome.uml";

	@Before @Override
	public void setup() throws Exception {
		super.setup();
	}

	@Test
	public void testEP_CoCoME_Cashdesk() throws Exception {
		assertTrue(rmv.validate(rcos));
		Command cmd;
		cmd = ExpertPatternClassCommand.runExpertPattern(editingDomain,errors,cashdesk);
		checkErrors(cmd);
		assertTrue(errors.toString(),rmv.validate(rcos));
		RCOSpecTranslation t = new RCOSpecTranslation();
		final String buf;
		System.err.println(buf = t.translate(rcos));
		MyRCOSModel m = new ParseRCOSModelTC(filename, "test", new RCOSFromString(buf));
		// TODO: did it do anything?
	}

	@Test
	public void testEP_CoCoME_Cashdesk_finishSale() throws Exception {
		ExpertPatternOperationCommand cmd;
		cmd = new ExpertPatternOperationCommand(editingDomain,errors,cashdesk.getOwnedOperation("finishSale", null, null, false, false));
		checkErrors(cmd);
		RCOSpecTranslation t = new RCOSpecTranslation();
		System.err.println(t.translate(rcos));
		assertTrue(errors.toString(),rmv.validate(rcos));
	}

	@Override
	public void teardown() {
		rmv = null;
	}
}
