package edu.unu.iist.rcos.spec.antlr.test;

import static org.junit.Assert.assertTrue;

import java.util.*;

import org.eclipse.emf.common.command.Command;
import org.junit.Before;
import org.junit.Test;

import edu.unu.iist.rcos.mm.resources.tests.CoCoME_Exe_Loader;
import edu.unu.iist.rcos.modeler.translation.RCOSpecTranslation;
import edu.unu.iist.rcos.spec.antlr.*;
import edu.unu.iist.rcos.spec.antlr.MyRCOSModel.RCOSFromString;
import edu.unu.iist.rcos.spec.antlr.commands.ExpertPatternClassCommand;
import edu.unu.iist.rcos.spec.antlr.commands.ExpertPatternOperationCommand;

public class Test_EP_CoCoME_Exe extends CoCoME_Exe_Loader {

	RCOSModelValidation rmv = new RCOSModelValidation();
	String filename = "scratch-ep-cocome.uml";
	List<Throwable> errs;

	@Before @Override
	public void setup() throws Exception {
		super.setup();
		errs = new ArrayList<Throwable>();
	}

	@Test
	public void testEP_CoCoME_Cashdesk() throws Exception {
		assertTrue(rmv.validate(rcos));
		Command cmd;
		editingDomain.getCommandStack().execute(
				cmd = ExpertPatternClassCommand.runExpertPattern(editingDomain,errs,cashdesk));
		assertTrue(errs.toString(),cmd.canExecute());
		assertTrue(errs.toString(),rmv.validate(rcos));
		RCOSpecTranslation t = new RCOSpecTranslation();
		final String buf;
		System.err.println(buf = t.translate(rcos));
		MyRCOSModel m = new ParseRCOSModelTC(filename, "test", new RCOSFromString(buf));
		// TODO: did it do anything?
	}

	@Test
	public void testEP_CoCoME_Cashdesk_finishSale() throws Exception {
		ExpertPatternOperationCommand cmd;
		editingDomain.getCommandStack().execute(
				cmd = new ExpertPatternOperationCommand(editingDomain,errs,cashdesk.getOwnedOperation("finishSale", null, null, false, false)));
		assertTrue(cmd.canExecute());
		RCOSpecTranslation t = new RCOSpecTranslation();
		System.err.println(t.translate(rcos));
		assertTrue(errs.toString(),rmv.validate(rcos));
	}

	@Override
	public void teardown() {
		rmv = null;
	}
}
