package edu.unu.iist.rcos.spec.antlr.test;

import static org.junit.Assert.*;

import org.eclipse.emf.common.util.URI;
import org.junit.*;

import edu.unu.iist.rcos.mm.resources.tests.CoCoME_Loader;
import edu.unu.iist.rcos.spec.antlr.RCOSModelUtility;
import edu.unu.iist.rcos.uml.RCOSLoader;

public class Test_IsTranslatable extends CoCoME_Loader {

	@Test
	public void test_CoCoME_TC() throws Exception {
		assertFalse(new RCOSModelUtility().isTranslatable(rcos).isOK());
	}
	
	@Test
	public void test_CoCoME_R_TC() throws Exception {
		RCOSLoader rm = new RCOSLoader(URI.createFileURI("../examples/CoCoME/cocome_usecase_refinement/CoCoME.uml"));
		assertFalse(new RCOSModelUtility().isTranslatable(rm.rcos).isOK());
	}
	
	@Test
	public void test_CoCoME_123_TC() throws Exception {
		RCOSLoader rm = new RCOSLoader(URI.createFileURI("../examples/CoCoME/cocome_usecase_refinement_1_2_3/CoCoME.uml"));
		assertFalse(new RCOSModelUtility().isTranslatable(rm.rcos).isOK());
	}
	
	@Test
	public void test_CoCoME_exe() throws Exception {
		RCOSLoader rm = new RCOSLoader(URI.createFileURI(cExe));
		assertTrue(new RCOSModelUtility().isTranslatable(rm.rcos).isOK());
	}
}
