package edu.unu.iist.rcos.spec.antlr.test;

import org.junit.Test;
import static org.junit.Assert.*;

import org.eclipse.uml2.uml.Class;
import org.eclipse.uml2.uml.*;
import edu.unu.iist.rcos.spec.antlr.MyRCOSModel;
import edu.unu.iist.rcos.spec.antlr.MyRCOSModel.*;

public class Test_MyRCOSModel {

	String file = "test.uml";
	String name = "test";
	
	@Test
	public void test_One_Place_Buffer() throws Exception {		
		new MyRCOSModel(file,name, new RCOSFromFile("../examples/OnePlaceBuffer/OnePlaceBuffer.rcosp"));
	}
	
	@Test
	public void test_guard_lost() throws Exception {
		MyRCOSModel rm = new MyRCOSModel("test.uml","test", new RCOSFromFile("testcases/tc/broken-primed-guard.rcosp"));
		Class a = (Class)rm.rcos.getClassModel().getBase_Package().getOwnedMember("A");
		assertNotNull(a);
		Operation op = a.getOperation("m", null, null);
		assertNotNull(op);
		assertTrue("Guard lost while parsing",op.getOwnedRules().size() > 0);
	}
}
