package edu.unu.iist.rcos.spec.antlr.test;

import org.junit.Test;

import edu.unu.iist.rcos.spec.antlr.ParseRCOSModelTC;
import edu.unu.iist.rcos.spec.antlr.MyRCOSModel.*;

public class Test_ParseRCOSModelTC {

	String file = "test.uml";
	String name = "test";
	
	@Test
	public void test_One_Place_Buffer() throws Exception {		
		new ParseRCOSModelTC(file, name, new RCOSFromFile("../examples/OnePlaceBuffer/OnePlaceBuffer.rcosp"));
	}

	@Test
	public void test_Documentation_exampleBuffer() throws Exception {
		new ParseRCOSModelTC(file, name, new RCOSFromFile("../documentation/RCOS_Syntax/examples/buffer.rcosp"));
	}

	@Test
	public void test_Documentation_exampleComposition() throws Exception {
		new ParseRCOSModelTC(file, name, new RCOSFromFile("../documentation/RCOS_Syntax/examples/exampleComposition.rcosp"));
	}
	
	@Test
	public void test_Documentation_fact() throws Exception {
		new ParseRCOSModelTC(file, name, new RCOSFromFile("../documentation/RCOS_Syntax/examples/fact.rcosp"));
	}
	
	@Test
	public void test_One_Place_Buffer1() throws Exception {		
		new ParseRCOSModelTC(file, name, new RCOSFromFile("../examples/one-place-buffer/OnePlace-OneIf-Mangle.rcosp"));
	}

	@Test
	public void test_One_Place_Buffer2() throws Exception {		
		new ParseRCOSModelTC(file, name, new RCOSFromFile("../examples/one-place-buffer/OnePlace-OneIf.rcosp"));
	}

	@Test
	public void test_One_Place_Buffer3() throws Exception {		
		new ParseRCOSModelTC(file, name, new RCOSFromFile("../examples/one-place-buffer/OnePlace-TwoIf.rcosp"));
	}

	@Test
	public void test_One_Place_Buffer4() throws Exception {		
		new ParseRCOSModelTC(file, name, new RCOSFromFile("../examples/one-place-buffer/OnePlace-TwoIfWrapped.rcosp"));
	}

}
