package edu.unu.iist.rcos.spec.antlr.test;

import static org.junit.Assert.*;

import org.eclipse.uml2.uml.Component;
import org.junit.Test;

import edu.unu.iist.rcos.modeler.translation.RCOSpecTranslation;
import edu.unu.iist.rcos.profile.ComponentContracts;
import edu.unu.iist.rcos.profile.ContractInterface;
import edu.unu.iist.rcos.spec.antlr.MyRCOSModel;
import edu.unu.iist.rcos.spec.antlr.ParseRCOSModelTC;
import edu.unu.iist.rcos.spec.antlr.MyRCOSModel.*;

public class Test_ParseRCOSModelTC_CoCoME {

	String filename="test.uml";
	String filename2="test-2.uml";
	
	@Test
	public void test_CoCoME_Parse() throws Exception {		
		new ParseRCOSModelTC(filename, "test", new RCOSFromFile("../examples/CoCoME/cocome/CoCoME.rcosp"));
	}
	
	@Test
	public void test_CoCoME_exe_Parse() throws Exception {
		new ParseRCOSModelTC(filename, "test", new RCOSFromFile("../examples/CoCoME/cocome/CoCoME-exe.rcosp"));
	}
	
	@Test
	public void test_CoCoME_R_Parse() throws Exception {
		new ParseRCOSModelTC(filename, "test", new RCOSFromFile("../examples/CoCoME/cocome_usecase_refinement/CoCoME.rcosp"));
	}
	
	@Test
	public void test_CoCoME_123_Parse() throws Exception {
		new ParseRCOSModelTC(filename, "test", new RCOSFromFile("../examples/CoCoME/cocome_usecase_refinement_1_2_3/CoCoME.rcosp"));
	}

	@Test
	public void test_CoCoME_R_Payment_Parse() throws Exception {
		MyRCOSModel rm = new ParseRCOSModelTC(filename, "test", new RCOSFromFile("../examples/CoCoME/cocome_usecase_refinement/CoCoME_Payment.rcosp"));
		rm.validate();
		Component processSale = rm.rcos.getComponent("ProcessSale", null);
		assertNotNull(processSale);
		Component payment = rm.rcos.getComponent("Payment", processSale);
		assertNotNull(payment);
		if (false) {
		Component p2 = rm.rcos.getComponent("Payment", null);
		assertNull(p2);
		}
		ComponentContracts cc = new ComponentContracts(payment);
		assertEquals(cc.providedList.toString(),1,cc.providedList.size());
		ContractInterface c = (ContractInterface) cc.providedList.toArray()[0];
		Component prov = c.getProvidedInterfaceComponent(payment);
		System.err.println(prov);
		RCOSpecTranslation trans = new RCOSpecTranslation();
		String out = trans.translate(rm.rcos);
		System.out.println(out);
		MyRCOSModel rm2 = new ParseRCOSModelTC(filename2,"test", new MyRCOSModel.RCOSFromString(out));
		rm2.validate();
	}
}
