package edu.unu.iist.rcos.spec.antlr.test;

import static org.junit.Assert.*;
import org.junit.Test;

import org.eclipse.emf.common.util.URI;

import edu.unu.iist.rcos.mm.resources.tests.CoCoME_Loader;
import edu.unu.iist.rcos.mm.util.WellformedException;
import edu.unu.iist.rcos.profile.RCOSModel;
import edu.unu.iist.rcos.spec.antlr.MyRCOSModel;
import edu.unu.iist.rcos.spec.antlr.RCOSModelCheckException;
import edu.unu.iist.rcos.spec.antlr.RCOSModelValidation;
import edu.unu.iist.rcos.spec.antlr.MyRCOSModel.RCOSFromFile;
import edu.unu.iist.rcos.uml.RCOSLoader;

public class Test_RCOSModelValidation_CoCoME extends CoCoME_Loader {

	// Load UML model, then call validate
	
	@Test
	public void test_CoCoME_TC() throws Exception {
		assertTrue(validate(rcos));
	}
	
	@Test
	public void test_CoCoME_R_TC() throws Exception {
		RCOSLoader rm = new RCOSLoader(URI.createFileURI("../examples/CoCoME/cocome_usecase_refinement/CoCoME.uml"));
		assertTrue(validate(rm.rcos));
	}
	
	@Test
	public void test_CoCoME_123_TC() throws Exception {
		RCOSLoader rm = new RCOSLoader(URI.createFileURI("../examples/CoCoME/cocome_usecase_refinement_1_2_3/CoCoME.uml"));
		assertTrue(validate(rm.rcos));
	}
	
	@Test
	public void test_CoCoME_exe_TC() throws Exception {
		RCOSLoader rm = new RCOSLoader(URI.createFileURI("../examples/CoCoME/cocome/CoCoME-exe.uml"));
		assertTrue(validate(rm.rcos));
	}

	String filename="test.uml";
	@Test
	public void test_CoCoME_Parse_Val() throws Exception {
		assertTrue(new MyRCOSModel(filename, "test", new RCOSFromFile("../examples/CoCoME/cocome/CoCoME.rcosp")).validate());
	}
	
	@Test
	public void test_CoCoME_exe_Parse_Val() throws Exception {
		MyRCOSModel m = new MyRCOSModel(filename, "test", new RCOSFromFile("../examples/CoCoME/cocome/CoCoME-exe.rcosp"));
		assertTrue(validate(m.rcos));
	}
	
	@Test
	public void test_CoCoME_R_Parse_Val() throws Exception {
		assertTrue(new MyRCOSModel(filename, "test", new RCOSFromFile("../examples/CoCoME/cocome_usecase_refinement/CoCoME.rcosp")).validate());
	}
	
	@Test
	public void test_CoCoME_123_Parse_Val() throws Exception {
		assertTrue(new MyRCOSModel(filename, "test", new RCOSFromFile("../examples/CoCoME/cocome_usecase_refinement_1_2_3/CoCoME.rcosp")).validate());
	}
	
	@Test
	public void test_CoCoME_R_Payment_Parse_Val() throws Exception {
		assertTrue(new MyRCOSModel(filename, "test", new RCOSFromFile("../examples/CoCoME/cocome_usecase_refinement/CoCoME_Payment.rcosp")).validate());
	}
	
	protected boolean validate(RCOSModel rm) throws RCOSModelCheckException, WellformedException {
		RCOSModelValidation rmv = new RCOSModelValidation();
		return rmv.validate(rm);
	}
}
