package edu.unu.iist.rcos.spec.antlr.test;

import static org.junit.Assert.assertTrue;

import org.eclipse.emf.common.util.URI;
import org.junit.Test;

import edu.unu.iist.rcos.mm.util.WellformedException;
import edu.unu.iist.rcos.profile.RCOSModel;
import edu.unu.iist.rcos.spec.antlr.MyRCOSModel;
import edu.unu.iist.rcos.spec.antlr.RCOSModelCheckException;
import edu.unu.iist.rcos.spec.antlr.RCOSModelValidation;
import edu.unu.iist.rcos.spec.antlr.MyRCOSModel.RCOSFromFile;
import edu.unu.iist.rcos.uml.RCOSLoader;

public class Test_RCOSModelValidation_TMS {


	// Load UML model, then call validate
	
	@Test
	public void test_TMS_TC() throws Exception {
		RCOSLoader loader = new RCOSLoader(URI.createFileURI("../examples/Trustable_Medical_System/TMS.uml"));
		assertTrue(validate(loader.rcos));
	}

	String filename="test.uml";
	@Test
	public void test_TMS_Parse_Val() throws Exception {
		assertTrue(new MyRCOSModel(filename, "test", new RCOSFromFile("../examples/Trustable_Medical_System/TMS.rcosp")).validate());
	}
	
	protected boolean validate(RCOSModel rm) throws RCOSModelCheckException, WellformedException {
		RCOSModelValidation rmv = new RCOSModelValidation();
		return rmv.validate(rm);
	}
}
