package edu.unu.iist.rcos.spec.antlr.test;

import static org.junit.Assert.*;
import org.junit.Test;

import org.eclipse.uml2.uml.Class;
import org.eclipse.uml2.uml.Operation;
import org.eclipse.uml2.uml.Type;

import edu.unu.iist.rcos.mm.resources.tests.CoCoME_Loader;
import edu.unu.iist.rcos.modeler.translation.RCOSpecTranslation;
import edu.unu.iist.rcos.modeler.translation.ValidatedRCOSSpecTranslation;
import edu.unu.iist.rcos.spec.antlr.MyRCOSModel;
import edu.unu.iist.rcos.spec.antlr.MyRCOSModel.*;
import edu.unu.iist.rcos.spec.antlr.visitor.check.ExpGetType;

public class Test_Return_types_lost extends CoCoME_Loader {

	@Test
	public void test_CoCoME_Parse_Bank_authorize_return_type_missing_1() throws Exception {
		// missing return type in rCOSp?
		String filename="test.uml";
		MyRCOSModel m = new MyRCOSModel(filename, "test", new RCOSFromFile("../examples/CoCoME/cocome/CoCoME.rcosp"));
		Class bank = (Class)m.rcos.getClassModel().getBase_Package().getOwnedMember("Bank");
		Operation op = bank.getOperation("authorize", null, null);
		Type res = new ExpGetType(op).getReturnType(op);
		assertNotNull("Can't find return type!",res);
		assertTrue(res.getQualifiedName(),res.getQualifiedName().equals("RCOSPrimitiveTypes::boolean"));
	}
	
	@Test
	public void test_CoCoME_Parse_Bank_authorize_return_type_missing_2() throws Exception {
		// missing return type after export?
		{ // base:
			Class bank = (Class)rcos.getClassModel().getBase_Package().getOwnedMember("Bank");
			Operation op = bank.getOperation("authorize", null, null);
			Type res = op.getType();
			assertTrue(res != null);
			assertTrue(res.getQualifiedName(),res.getQualifiedName().equals("RCOSPrimitiveTypes::boolean"));
		}
		String filename="test.uml";
		RCOSpecTranslation t = new ValidatedRCOSSpecTranslation();
		String buf = t.translate(rcos);		
		MyRCOSModel m = new MyRCOSModel(filename, "test", new RCOSFromString(buf));
		Class bank = (Class)m.rcos.getClassModel().getBase_Package().getOwnedMember("Bank");
		Operation op = bank.getOperation("authorize", null, null);
		Type res = new ExpGetType(op).getReturnType(op);
		assertNotNull("Can't find return type!",res);
		assertTrue(res.getQualifiedName().equals("RCOSPrimitiveTypes::boolean"));
	}
}
