package edu.unu.iist.rcos.spec.antlr.test;

import static org.junit.Assert.*;
import org.junit.Test;

import org.eclipse.uml2.uml.Operation;

import edu.unu.iist.rcos.mm.resources.tests.CoCoME_Loader;
import edu.unu.iist.rcos.spec.antlr.DesignUtility;
import edu.unu.iist.rcos.spec.antlr.Parse;
import edu.unu.iist.rcos.spec.antlr.SyntaxTree.SyntaxTree_ClassModel.DESIGN;

public class Test_getAllOperations extends CoCoME_Loader {

	@Test
	public void test_getAllOperations_enterItem() throws Exception {
		// missing return type in rCOSp?
		Operation ei = cashdesk.getOperation("enterItem", null, null);
		DESIGN d = Parse.getDesign(ei);
		assertTrue("Wrong number of method call in enterItem", DesignUtility.getAllOperations(d, cashdesk).size() == 3) ;	
	}
	
	@Test
	public void test_getAllOperations_finishSale() throws Exception {
		// missing return type in rCOSp?
		Operation ei = cashdesk.getOperation("finishSale", null, null);
		DESIGN d = Parse.getDesign(ei);
		assertTrue("Wrong number of method call in finishSale", DesignUtility.getAllOperations(d, cashdesk).size() == 0) ;	
	}
	
	@Test
	public void test_getAllOperations_cardPay() throws Exception {
		// missing return type in rCOSp?
		Operation ei = cashdesk.getOperation("cardPay", null, null);
		DESIGN d = Parse.getDesign(ei);
		assertTrue("Wrong number of method call in cardPay", DesignUtility.getAllOperations(d, cashdesk).size() == 4) ;	
	}

}
