package edu.unu.iist.rcos.spec.antlr.test.charles;

import static org.junit.Assert.*;
import org.junit.Test;

import org.eclipse.emf.common.util.URI;

import edu.unu.iist.rcos.mm.resources.tests.CoCoME_Loader;
import edu.unu.iist.rcos.mm.util.WellformedException;
import edu.unu.iist.rcos.profile.RCOSModel;
import edu.unu.iist.rcos.spec.antlr.MyRCOSModel;
import edu.unu.iist.rcos.spec.antlr.RCOSModelCheckException;
import edu.unu.iist.rcos.spec.antlr.RCOSModelValidation;
import edu.unu.iist.rcos.spec.antlr.MyRCOSModel.RCOSFromFile;
import edu.unu.iist.rcos.uml.RCOSLoader;

public class Test_RCOSModelValidation_Isabelle extends CoCoME_Loader {

	String filename="test.uml";
	@Test
	public void test_Isabelle_umlfm() throws Exception {
		assertTrue(new MyRCOSModel(filename, "test", new RCOSFromFile("testcases/isabelle/umlfm.rcosp")).validate());
	}
	
	@Test
	public void test_Isabelle_itp() throws Exception {
		MyRCOSModel myRCOSModel = new MyRCOSModel(filename, "test", new RCOSFromFile("testcases/isabelle/itp.rcosp"));
		assertTrue(myRCOSModel.validate());
		myRCOSModel.save();
	}
	
	@Test
	public void test_Isabelle_sbmf() throws Exception {
		MyRCOSModel myRCOSModel = new MyRCOSModel(filename, "test", new RCOSFromFile("testcases/isabelle/sbmf.rcosp"));
		assertTrue(myRCOSModel.validate());
		myRCOSModel.save();
	}
	
	@Test
	public void test_Isabelle_output() throws Exception {
		MyRCOSModel myRCOSModel = new MyRCOSModel(filename, "test", new RCOSFromFile("testcases/isabelle/testOutputParam.rcosp"));
		assertTrue(myRCOSModel.validate());
		myRCOSModel.save();
	}
	
	protected boolean validate(RCOSModel rm) throws RCOSModelCheckException, WellformedException {
		RCOSModelValidation rmv = new RCOSModelValidation();
		return rmv.validate(rm);
	}
}
