package edu.unu.iist.rcos.spec.antlr.test.charles;

import java.util.ArrayList;
import java.util.List;

import org.junit.Test;

import static edu.unu.iist.rcos.spec.antlr.Parse.*;
import static edu.unu.iist.rcos.spec.antlr.DesignUtility.*;

public class Test_simplification {
	
	@Test
	public void testDesignParsing() throws Exception{
		
		List<String> l	= new ArrayList<String>(20);
		l.add("quantity := 2");
		l.add("var C x; x := 2");
		l.add("x:= x; y := 2; x:= 2");
		l.add("x := y");
		l.add("if (b) then {x := 3} else {y := 4}");
		l.add("if (true) then {x := 3} else {y := 4}");
		l.add("if (b) then {skip} else {skip}; skip");
		l.add("while (b) {x := 3; x := y}");
		l.add("x:= 2 \\/ x := y");
		l.add("m(a, b; x, y)");
		l.add("n(2).m(a, b; x, y)");
		l.add("m(c', d; x, y)");
		l.add("m(e', f'; x, y)");
		l.add("skip");
		l.add("n()");
		l.add("skip; x:= 2");
		l.add("[ x' = 2 |- x' = y AND x' = 3]");
		l.add("return 3");
		l.add("skip; return 2");
		
		System.out.println("\n********************************** Start of copy designs ***************************************\n");
		for (String d : l){
			System.out.println("\"" + d + "\"" + " is simplified to \"" +  designToString(simplifyDesign(getDesignFromString(d))) + "\"");
		}
		System.out.println("\n********************************** End of copy designs ***************************************\n");
	}
	
	@Test
	public void testExpression() throws Exception{

		List<String> l = new ArrayList<String>(20);
		 l.add("0");
		 l.add("true");
		 l.add("1 + 2");
		 l.add("x + 3");
		 l.add("z + y");
		 l.add("w = 5");
		 l.add("p' = 5");
		 l.add("m(1)");
		 l.add("m(x)");
		 l.add("n(2).m(a, b)");
		 l.add("m(n(3))");
		 l.add("m(n(3, 4, f(5)))");
		 l.add("m(a, b)");
		 l.add("m(c', d; x)");
		 l.add("m(e', f'; x, y)");
		 l.add("\\forall T x : x' = 8");
		 l.add("\\forall T x : x = 8 AND y > 9");
		 l.add("x.y' + x.z");
		 l.add("x' = 2 AND y = 3 AND z' = 7 OR x' = 1");
		 l.add("true AND true");
		 l.add("true AND x AND true");
		 l.add("x AND (true OR y)");
		 
		 System.out.println("\n********************************** Start of copy exp ***************************************\n");
			for (String d : l){
				System.out.println("\"" + d + "\"" + " is simplified to \"" +  expToString(simplifyExpression(getExpFromString(d))) + "\"");
			}
			System.out.println("\n********************************** End of copy exp ***************************************\n");
	}
}
