package edu.unu.iist.rcos.spec.antlr.visitor.transformation.delegation;

import static org.junit.Assert.*;

import org.eclipse.uml2.uml.Operation;
import org.junit.Test;

import edu.unu.iist.rcos.mm.resources.tests.CoCoME_Loader;
import edu.unu.iist.rcos.spec.antlr.Parse;
import edu.unu.iist.rcos.spec.antlr.TypeHandler;
import edu.unu.iist.rcos.spec.antlr.VardeclsFIS;
import edu.unu.iist.rcos.spec.antlr.SyntaxTree.SyntaxTree_ClassModel.*;
import edu.unu.iist.rcos.spec.antlr.visitor.expprefix.ExpPrefixFilterVisitor;
import edu.unu.iist.rcos.spec.antlr.visitor.transformation.delegation.DelegationException;
import edu.unu.iist.rcos.spec.antlr.visitor.transformation.delegation.DesignDelegator;

/**
 * @author stolz
 *
 */
public class Test_DelegationMisc extends CoCoME_Loader {

	@Test
	public void test() throws Exception {
		PREFIX p1 = (PREFIX) Parse.getGuard("sale",cashdesk.getOwnedOperations().get(0));
		PREFIX p2 = (PREFIX) Parse.getGuard("store.sales",cashdesk.getAllOperations().get(0));
		PREFIX p = ExpPrefixFilterVisitor.bestOf(p1,p2);
		String msg = String.valueOf(p);
		assertTrue(msg, p == null || p instanceof THIS );
	}

	// TODO: Proper tests for CoCoME
	@Test
	public void test_no_RuntimeException() throws Exception {
		REF tgt = (REF) Parse.getGuard("sale",cashdesk.getOwnedOperations().get(0));
		for (Operation op: cashdesk.getOwnedOperations()) {
			try {
			DesignDelegator dd = new DesignDelegator(editingDomain, op, tgt, new VardeclsFIS(op, new TypeHandler(rcos)));
			DESIGN d = Parse.getDesign(op);
			dd.run(d);
			} catch (DelegationException e) {
				// We only want to make sure that there are no RuntimeExceptions.
			}
		}
	}

}
