package edu.unu.iist.rcos.modeler.translation;

import edu.unu.iist.rcos.mm.util.WellformedException;
import edu.unu.iist.rcos.profile.RCOSModel;
import edu.unu.iist.rcos.spec.antlr.RCOSModelCheckException;
import edu.unu.iist.rcos.spec.antlr.RCOSModelValidation;

/**
 * @author stolz
 * This class has the validation build in for convenience. 
 */
public class ValidatedRCOSSpecTranslation extends RCOSpecTranslation {

	public String translate(RCOSModel rm) throws ExportException {
		final RCOSModelValidation rmv = new RCOSModelValidation();
		try {
			if (!rmv.validateReq(rm))
				throw new ExportException("Refusing to export non Requirement models: validateReq() failed.");
		} catch (RCOSModelCheckException e) {
			throw new ExportException("Refusing to export non Requirement model:\n"+ e,e);
		} catch (WellformedException e) {
			throw new ExportException("Refusing to export malformed model:\n"+ e,e);
		}
		return super.translate(rm);
	}
}
