package edu.unu.iist.rcos.spec.antlr;

import java.util.ArrayList;
import java.util.List;

public class MethodSignature {
	final String name;
	final List<String> in;
	final List<String> out;
	
	public MethodSignature(String n){
		this(n,new ArrayList<String>(), new ArrayList<String>());
	}
	
	public MethodSignature(String n, List<String> i, List<String> o) {
		name = n;
		in = i;
		out = o;
	}
	
	public void addIn(String par){
		in.add(par);
	}
	
	public void addOut(String par){
		out.add(par);
	}
	
	@Override
	// Warning: hashCode is not overridden, so don't use a MethodSignature has a key for a HashMap
	public boolean equals(Object o) {
		MethodSignature m;
		if (! (o instanceof MethodSignature)) {
			throw new RuntimeException("Trying to compare a MethodSignature with something else");
		} else {
			m = (MethodSignature) o;
		}
		if (name.equals(m.name) && in.size() == m.in.size() && out.size() == m.out.size()){
			int i = 0;
			for (i = 0; i < in.size(); i++){
				if (!in.get(i).equals(m.in.get(i))) return false;
			}
			for (i = 0; i < out.size(); i++){
				if (!out.get(i).equals(m.out.get(i))) return false;
			}

			return true;
		} else {
			return false;
		}
	}
	
	public String print(){
		return name + " : " + in.toString() + ", " + out.toString();
	}
}
