package edu.unu.iist.rcos.spec.antlr;

import java.io.IOException;
import java.util.concurrent.Callable;

import org.antlr.runtime.ANTLRStringStream;
import org.antlr.runtime.RecognitionException;
import org.eclipse.emf.common.util.URI;

import edu.unu.iist.rcos.spec.tc.TCAble;
import edu.unu.iist.rcos.uml.NotAnRCOSModelException;

/**
 * @author stolz
 * Constructor to load an rCOSp-file and type check it.
 */

public class ParseRCOSModelTC extends MyRCOSModel {

	public ParseRCOSModelTC(String xmi_file, String model_name, ANTLRStringStream f)
	throws RecognitionException, NotAnRCOSModelException, IOException {
		this(URI.createFileURI(xmi_file), model_name,f);
	}

	//Type checking
	public ParseRCOSModelTC(URI xmi_file, String model_name, ANTLRStringStream f)
	throws RecognitionException, NotAnRCOSModelException, IOException {
		super(xmi_file, model_name);
		this.tc = new TCAble(){ public boolean isEnabled() { return true; }};
		helpMe(f); 
		for (Callable<?> r : tcQ) {
			try {
				r.call();
			} catch (RecognitionException e) {
				throw e;
			} catch (Exception e) {
				/* This should not happen */
				e.printStackTrace();
				throw new RuntimeException(e);
			}
		}
	}
}