package edu.unu.iist.rcos.spec.antlr.commands;

import org.eclipse.uml2.uml.Classifier;

import edu.unu.iist.rcos.spec.antlr.*;
import edu.unu.iist.rcos.spec.antlr.SyntaxTree.SyntaxTree_ClassModel.*;
import edu.unu.iist.rcos.spec.antlr.visitor.transformation.refinement.DesignRefinement;
import edu.unu.iist.rcos.spec.antlr.visitor.transformation.refinement.ExpRefinement;
import edu.unu.iist.rcos.spec.antlr.visitor.transformation.refinement.RefinementException;

/**
 * In an invariant, we rewrite "DASHABLE !=/== null" to true/false.
 * TODO: accept more variations?
 * TODO: use ExpAbstraction?
 * TODO: simplify resulting expression; currently you have to do it yourself
 * @author stolz
 */
public class AssertNotNullVisitor extends ExpRefinement<RefinementException> {

	final private DASHABLE da;

	public AssertNotNullVisitor(DASHABLE da) {
		this.da = da;
	}

	@Override protected void visit(RELOP rop) throws RefinementException {
		if (rop.getOp() == RelOps.EQ && rop.getRight() instanceof NULL) {
			if (rop.getLeft() instanceof DASHABLE) {
				if (DesignUtility.isExpEqual(rop.getLeft(),da))
				{ set(MyDesign.createFalse()); return; }
			}
		} else if (rop.getOp() == RelOps.NEQ && rop.getRight() instanceof NULL) {
			if (rop.getLeft() instanceof DASHABLE) {
				if (DesignUtility.isExpEqual(rop.getLeft(),da))
				{ set(MyDesign.createTrue()); return; }
			}
		}
		super.visit(rop);
	}
	
	public class DesignVisitor extends DesignRefinement<RefinementException, AssertNotNullVisitor> {

		public DesignVisitor(Classifier cl) {
			super(AssertNotNullVisitor.this, cl);
		}
	}
}