package edu.unu.iist.rcos.spec.antlr.commands;

import org.eclipse.uml2.uml.Component;
import org.eclipse.uml2.uml.Interface;
import org.eclipse.uml2.uml.Usage;

public interface AssociationToRequiredInterfaceProvider<DP> extends DeleteProvider<DP>, DeleteAssoc<DP>{
	/**
	 * You can use getCI() to obtain the result from the command.
	 * Obviously you MUST NOT access stCmd directly, but it must be wrapped inside
	 * another command so that it only gets executed AFTER the A-S-Command has been
	 * executed.
	 */
	void createEdge(Interface stCmd, Usage u, Component co);
	void undoExecuted(); // Could be higher up/own interface
}