package edu.unu.iist.rcos.spec.antlr.commands;

import java.util.List;

import org.eclipse.emf.common.command.*;
import org.eclipse.emf.edit.domain.EditingDomain;
import org.eclipse.uml2.uml.Operation;

import edu.unu.iist.rcos.mm.RCOSCommand;
import edu.unu.iist.rcos.mm.util.DesignsED;
import edu.unu.iist.rcos.profile.*;
import edu.unu.iist.rcos.spec.antlr.DesignUtility;
import edu.unu.iist.rcos.spec.antlr.Parse;
import edu.unu.iist.rcos.spec.antlr.SyntaxTree.SyntaxTree_ClassModel.DESIGN;

public class AutorefineCommand extends RCOSCommand<Autorefine> {

	public AutorefineCommand(EditingDomain ed, List<Throwable> errors, Autorefine p) {
		super(ed, errors, p);
	}

	public AutorefineCommand(EditingDomain editingDomain, Autorefine autorefine) {
		super(editingDomain,autorefine);
	}

	public AutorefineCommand(){}
	@Override public Command createCommand() {
		final DesignsED ded = new DesignsED(domain);
		try {
			// isPessimistic essential here! Otherwise e.g. only the last operation will be undone on undo!
			// TODO: I'm pretty sure IdentityCommand.chain() should also work.
			CompoundCommand cmp = new StrictCompoundCommand("Autorefine Operations"){{ isPessimistic = true;}};
			for (Operation op : params.getOperations()) {
				String d = ded.get(op);
				if (d == null) continue;
				DESIGN des = Parse.getDesign(op);
				DESIGN v = DesignUtility.refine(des, op.getClass_());
				cmp.append(ded.update(op, DesignUtility.designToString(op,v)));
			}
			cmp.append(IdentityCommand.INSTANCE);
			return cmp.unwrap();
		} catch (Exception e) {
			return recordError(e);
		}
	}
}
