package edu.unu.iist.rcos.spec.antlr.commands;

import java.util.List;

import org.eclipse.emf.common.command.Command;
import org.eclipse.emf.common.command.StrictCompoundCommand;
import org.eclipse.emf.edit.domain.EditingDomain;
import org.eclipse.uml2.uml.Operation;

import edu.unu.iist.rcos.mm.RCOSCommand;
import edu.unu.iist.rcos.profile.ExpertPatternOperationParameters;
import edu.unu.iist.rcos.profile.ProfileFactory;
import edu.unu.iist.rcos.spec.antlr.RCOSModelUtility;
import edu.unu.iist.rcos.spec.transformer.DesignTransformerEPGetED;
import edu.unu.iist.rcos.spec.transformer.DesignTransformerEPSetED;

public class ExpertPatternOperationCommand extends RCOSCommand<ExpertPatternOperationParameters> {

	public ExpertPatternOperationCommand(EditingDomain ed,
			List<Throwable> errors, ExpertPatternOperationParameters p) {
		super(ed, errors, p);
	}

	public ExpertPatternOperationCommand(EditingDomain editingDomain,
			List<Throwable> errors, Operation op) {
		this(editingDomain, errors, ProfileFactory.eINSTANCE.createExpertPatternOperationParameters(op));
	}

	public ExpertPatternOperationCommand(){}
	@Override public Command createCommand() {
		final Operation element = params.getOperation();
		StrictCompoundCommand cmp = new StrictCompoundCommand("Apply expert pattern on operation "+element.getName()) {{ isPessimistic = true; }};
		cmp.append(RCOSModelUtility.transform(domain,element.getClass_(),new DesignTransformerEPSetED(domain),element));
		cmp.append(RCOSModelUtility.transform(domain,element.getClass_(),new DesignTransformerEPGetED(domain),element));
		return cmp.unwrap();
	}
}
