package edu.unu.iist.rcos.spec.antlr.visitor;

import edu.unu.iist.rcos.spec.antlr.SyntaxTree.SyntaxTree_ClassModel.*;

/**
 * Same as ExpGenVisitor: only takes care of the cast.
 * @param <RD>
 * @param <RE> 
 * @param <RT>
 * @param <E>  extends VisitorException
 * @param <TV> extends TypeBaseVisitor<RT, E>
 * @param <EV> extends ExpGenVisitor<RE,RT,E,TV>
 * @author charles
 */
public abstract class DesignGenVisitor<RD,RE,RT, 
	E  extends VisitorException,
 	TV extends TypeBaseVisitor<RT, E>, 
 	EV extends ExpGenVisitor<RE,RT,E,TV>> extends DesignBaseVisitor<RD,RE,RT,E,TV,EV> {
	
	/* The following field can't be final because we don't know if we need fresh visitor unless
	 * we introduce EV.reset();
	 */
	protected EV ev;

	public DesignGenVisitor(EV ev) {
		if (ev == null)
			throw new IllegalArgumentException();
		this.ev = ev;
	}

	protected void visit(EXP e) throws E{ 
		ev.visit(e);
	}	
}
