package edu.unu.iist.rcos.spec.antlr.visitor;

import java.util.ArrayList;
import java.util.List;

import edu.unu.iist.rcos.spec.antlr.MyDesign;
import edu.unu.iist.rcos.spec.antlr.SyntaxTree.SyntaxTree_ClassModel.BOOLEAN;
import edu.unu.iist.rcos.spec.antlr.SyntaxTree.SyntaxTree_ClassModel.CHAR;
import edu.unu.iist.rcos.spec.antlr.SyntaxTree.SyntaxTree_ClassModel.DOUBLE;
import edu.unu.iist.rcos.spec.antlr.SyntaxTree.SyntaxTree_ClassModel.GTYPE;
import edu.unu.iist.rcos.spec.antlr.SyntaxTree.SyntaxTree_ClassModel.INT;
import edu.unu.iist.rcos.spec.antlr.SyntaxTree.SyntaxTree_ClassModel.LONG;
import edu.unu.iist.rcos.spec.antlr.SyntaxTree.SyntaxTree_ClassModel.NAT;
import edu.unu.iist.rcos.spec.antlr.SyntaxTree.SyntaxTree_ClassModel.STRING;
import edu.unu.iist.rcos.spec.antlr.SyntaxTree.SyntaxTree_ClassModel.TYPE;

/**
 * @author charles
 *
 */
public class TypeCopy<E extends VisitorException> extends TypeGenVisitor<TYPE, E> {

	@Override
	protected void visit(NAT d) throws E {
		set(MyDesign.createNat());
	}

	@Override
	protected void visit(CHAR d) throws E {
		set(MyDesign.createChar());
	}

	@Override
	protected void visit(LONG d) throws E {
		set(MyDesign.createLong());
	}

	@Override
	protected void visit(DOUBLE d) throws E {
		set(MyDesign.createDouble());
	}

	@Override
	protected void visit(BOOLEAN d) throws E {
		set(MyDesign.createBoolean());
	}

	@Override
	protected void visit(GTYPE d) throws E {
		List<TYPE> l = new ArrayList<TYPE>();
		for (TYPE t : d.getPar()) {
			l.add(run(t));
		}
		set(MyDesign.createGenericType(d.getName().getName(), l, null));
	}

	@Override
	protected void visit(INT d) throws E {
		set(MyDesign.createInt());
	}

	@Override
	protected void visit(STRING d) throws E {
		set(MyDesign.createString());	
	}
}
