package edu.unu.iist.rcos.spec.antlr.visitor;

import edu.unu.iist.rcos.spec.antlr.SyntaxTree.SyntaxTree_ClassModel.*;

/**
 * @author charles
 *
 */
public abstract class TypeGenVisitor<R, E extends VisitorException> extends TypeBaseVisitor<R, E> {

		@Override
		public void visit(TYPE t) throws E {
			init = true;
			if (t instanceof BTYPE) {
				visit((BTYPE) t);
			} else if (t instanceof GTYPE) {
				visit((GTYPE) t);
			}
		}
		
		protected void visit(BTYPE t) throws E {
			if (t instanceof INT) {
				visit((INT) t);
			} else if (t instanceof DOUBLE) {
				visit((DOUBLE) t);
			} else if (t instanceof BOOLEAN) {
				visit((BOOLEAN) t);
			} else if (t instanceof STRING) {
				visit((STRING) t);
			} else if (t instanceof CHAR) {
				visit((CHAR) t);
			} else if (t instanceof NAT) {
				visit((NAT) t);
			} else if (t instanceof LONG) {
				visit((LONG) t);
			} else
				assert false : t;
		}
		
		abstract protected void visit(NAT d) throws E;
		abstract protected void visit(CHAR d) throws E;
		abstract protected void visit(LONG d) throws E;
		abstract protected void visit(DOUBLE d) throws E;
		abstract protected void visit(BOOLEAN d) throws E;
		abstract protected void visit(GTYPE d) throws E;
		abstract protected void visit(INT d) throws E;
		abstract protected void visit(STRING d) throws E;

		@Override
		public R run(TYPE t, R r) {
			try {
				return run(t);
			} catch (VisitorException ex) {
				return r;
			}
		}
}
