package edu.unu.iist.rcos.spec.antlr.visitor;

import org.eclipse.uml2.uml.Type;

import edu.unu.iist.rcos.spec.antlr.SyntaxTree.SyntaxTree_ClassModel.*;

/**
 * @author charles
 * 
 */
public class TypePrinter<E extends PrinterException> extends TypeGenVisitor<String, E> {

	@Override
	protected void visit(NAT d) {
		set("nat");
	}

	@Override
	protected void visit(CHAR d) {
		set("char");
	}

	@Override
	protected void visit(LONG d) {
		set("long");
	}

	@Override
	protected void visit(DOUBLE d) {
		set("double");
	}

	@Override
	protected void visit(BOOLEAN d) {
		set("boolean");
	}

	@Override
	protected void visit(INT d) {
		set("int");
	}

	@Override
	protected void visit(STRING d) {
		set("string");
	}

	@Override
	protected void visit(GTYPE d) throws E {
		String res = d.getName().getName();
		if (d.getPar().size() > 0) {
			res += "<";
			for (TYPE t : d.getPar()) {
				res += run(t) + ",";
			}
			// Remove the last comma
			res = res.substring(0, res.length() - 1);
			res += ">";
		}
		
		set(res);
	}
	
	public String generateInitialValue(TYPE type) {
		if (type instanceof INT || type instanceof NAT || type instanceof LONG)
			return "0";
		else if (type instanceof BOOLEAN)
			return "false";
		else if (type instanceof DOUBLE)
			return "0.0";
		else if (type instanceof CHAR)
			return "\' \'";
		else if (type instanceof STRING)
			return "\"\"";
		else return "null";
	}

	public String generateInitialValue(Type type) {
		String name = type.getName();
		if (name.equals("int") || name.equals("long") || name.equals("nat") )
			return "0";
		else if (name.equals("boolean"))
			return "false";
		else if (name.equals("double"))
			return "0.0";
		else if (name.equals("char"))
			return "\' \'";
		else if (name.equals("String"))
			return "\"\"";
		else return "null";
	}
}