package edu.unu.iist.rcos.spec.antlr.visitor.check;

import edu.unu.iist.rcos.spec.antlr.SyntaxTree.SyntaxTree_ClassModel.*;
import edu.unu.iist.rcos.spec.antlr.visitor.*;

public class DesignIsTranslatable extends DesignGenVisitor<Boolean,Boolean, Void, VisitorException,TypeBaseVisitor<Void, VisitorException>, ExpIsSimpleExpression> {
	
	public DesignIsTranslatable(){
		super(new ExpIsSimpleExpression());
	}

	/**
	 * @author Charles Morisset
	 * @param m
	 * @throws VisitorException
	 */
	@Override
	protected void visit(MCALL m) throws VisitorException {
		set(true);
	}

	@Override
	protected void visit(PP d) throws VisitorException {
		set(false);	
	}

	@Override
	protected void visit(IF d) throws VisitorException {
		ev.reset();
		set(ev.run(d.getB()) && run(d.getLeft()) && run(d.getRight()));			
	}

	@Override
	protected void visit(CHOICE d) throws VisitorException {
		set(false);		
	}

	@Override
	protected void visit(SEQ d) throws VisitorException {
		set(run(d.getLeft()) && run(d.getRight()));
	}

	@Override
	protected void visit(WHILE d) throws VisitorException {
		ev.reset();
		set(ev.run(d.getB()) && run(d.getDo()));		
	}

	@Override
	protected void visit(FOR d) throws VisitorException {
		set(run(d.getDo()));			
	}

	@Override
	protected void visit(ASSIGN a) throws VisitorException {
		ev.reset();
		set(ev.run(a.getE()));		
	}

	@Override
	protected void visit(VARDECL d) throws VisitorException {
		set(true);
	}

	@Override
	protected void visit(ENDDECL d) throws VisitorException {
		set(true);		
	}

	@Override
	protected void visit(SKIP d) throws VisitorException {
		set(true);		
	}

	@Override
	protected void visit(CHAOS d) throws VisitorException {
		set(true);		
	}

	@Override
	protected void visit(MAGIC d) throws VisitorException {
		set(true);		
	}

	@Override
	protected void visit(STOP d) throws VisitorException {
		set(true);		
	}

	@Override
	protected void visit(RET d) throws VisitorException {
		set(true);		
	}

	@Override
	protected void visit(CHOKE d) throws VisitorException {
		throw new UnsupportedOperationException();
	}
}
