package edu.unu.iist.rcos.spec.antlr.visitor.check;

import org.eclipse.emf.common.util.EList;

import edu.unu.iist.rcos.spec.antlr.DesignUtility;

import edu.unu.iist.rcos.spec.antlr.SyntaxTree.SyntaxTree_ClassModel.*;
import edu.unu.iist.rcos.spec.antlr.visitor.TypeGenVisitor;
import edu.unu.iist.rcos.spec.antlr.visitor.VisitorException;

/**
 * @author charles
 *
 */
public class TypeEqual extends TypeGenVisitor<Boolean, VisitorException> {

	final TYPE t;
	
	public TypeEqual(TYPE t2){
		assert t2 != null;
		t = t2;
		state = false;
	}

	@Override
	protected void visit(NAT d) throws VisitorException {
		set(t instanceof NAT);
	}

	@Override
	protected void visit(CHAR d) throws VisitorException {
		set(t instanceof CHAR);
	}

	@Override
	protected void visit(LONG d) throws VisitorException {
		set(t instanceof LONG);
	}

	@Override
	protected void visit(DOUBLE d) throws VisitorException {
		set(t instanceof DOUBLE);
	}

	@Override
	protected void visit(BOOLEAN d) throws VisitorException {
		set(t instanceof BOOLEAN);
	}

	@Override
	protected void visit(GTYPE d) throws VisitorException {
		if (! (t instanceof GTYPE)) {
			set(false); return;
		} else {
			final EList<TYPE> tp = ((GTYPE) t).getPar();
			final EList<TYPE> dp = d.getPar();
			if (tp.size() != dp.size()) {
				set(false); return; 
			} else {
				for (int i = 0; i < tp.size() - 1 ; i++) {
					if ( ! DesignUtility.isTypeEqual(tp.get(i), dp.get(i))) {
						set(false); return;
					}
				}
				set(true); return;
			}		
		}
	}

	@Override
	protected void visit(INT d) throws VisitorException {
		set(t instanceof INT);	
	}

	@Override
	protected void visit(STRING d) throws VisitorException {
		set(t instanceof STRING);	
	}
}
