package edu.unu.iist.rcos.spec.antlr.visitor.toUTF8;

import org.eclipse.uml2.uml.Class;
import org.eclipse.uml2.uml.Operation;

import edu.unu.iist.rcos.profile.RCOSModel;
import edu.unu.iist.rcos.spec.antlr.VardeclsFIS;
import edu.unu.iist.rcos.spec.antlr.visitor.ExpPrinter;

public class UTF8ExpPrinter extends ExpPrinter {

	public UTF8ExpPrinter(RCOSModel rm, Operation op) {
		this(new VardeclsFIS(op, rm));
	}

	public UTF8ExpPrinter(RCOSModel rm, Class c) {
		this(new VardeclsFIS(c, rm));
	}

	public UTF8ExpPrinter(VardeclsFIS v) {
		super(v);
		AND = "\u2227"; // "∧";
		OR = "\u2228"; // "∨";		
		EXISTS = "\u2203"; // "∃";
		FORALL = "\u2200"; // "∀";
		ELEM = "\u220A"; // "∊";
		NEG = "\u00ac"; // ¬
		IMP = "\u21d2"; // ⇒
		EQUIV = "\u21d4"; // ⇔
	}
}
