package edu.unu.iist.rcos.spec.antlr.visitor.toUTF8;

import org.eclipse.uml2.uml.Operation;

import edu.unu.iist.rcos.profile.RCOSModel;
import edu.unu.iist.rcos.spec.antlr.Vardecls;
import edu.unu.iist.rcos.spec.antlr.SyntaxTree.SyntaxTree_ClassModel.*;
import edu.unu.iist.rcos.spec.antlr.visitor.DesignPrinter;
import edu.unu.iist.rcos.spec.antlr.visitor.PrinterException;

public class UTF8Printer extends DesignPrinter<UTF8ExpPrinter> {
	final char IF_L = '\u22B2'; // '⊲';
	final char IF_R = '\u22B3'; // '⊳';
	final char WHILE = '\u2217'; // '∗';

	public UTF8Printer(RCOSModel rm, final Operation op) {
		super(new UTF8ExpPrinter(rm, op), op);
		TSTILE = "\u22A2";
	}

	public UTF8Printer(Vardecls vfis, UTF8ExpPrinter ep) {
		super(vfis,ep);
		TSTILE = "\u22A2"; // eek!
	}

	@Override
	protected void visit(IF d) throws PrinterException {
		String s1 = "{"+ run(d.getLeft())+ "}" + IF_L;
		/* note that the difference between strings and chars here is significant! */
		String s2 = IF_R+ "{"+ run(d.getRight()) + "}";
		set(s1 + getString(d.getB()) + s2);
	}

	@Override
	protected void visit(WHILE w) throws PrinterException {
		String b = ev.run(w.getB());
		String d = run(w.getDo());
		set('('+b+')' + WHILE + '{' + d +'}');
	}
}
