package edu.unu.iist.rcos.spec.antlr.visitor.transformation;

import org.eclipse.uml2.uml.Classifier;

import edu.unu.iist.rcos.spec.antlr.DesignUtility;
import edu.unu.iist.rcos.spec.antlr.SyntaxTree.SyntaxTree_ClassModel.*;
import edu.unu.iist.rcos.spec.antlr.visitor.transformation.refinement.DesignRefinement;
import edu.unu.iist.rcos.spec.antlr.visitor.transformation.refinement.RefinementException;

/**
 * @author stolz
 * Rewrite
 *   if b then SKIP else CHAOS; CMD
 * and its friends to:
 *   if b then CMD else CHAOS.
 */
public class DesignPullUpIfSkipChaos extends DesignRefinement<RefinementException,ExpSimplification>{

	public DesignPullUpIfSkipChaos(Classifier cl) {
		super(new ExpSimplification(), cl);
	}

	@Override
	protected void visit(SEQ s) throws RefinementException {
		super.visit(s);
		DESIGN left = s.getLeft();
		DESIGN right = s.getRight();
		if (left instanceof IF) {
			IF ifD = (IF)left;
			if (ifD.getLeft() instanceof SKIP
					&& DesignUtility.isDeadBranch(ifD.getRight())) {
				setModified(ifD);
				ifD.setLeft(right);
			} else if (ifD.getRight() instanceof SKIP
					&& DesignUtility.isDeadBranch(ifD.getLeft())) {
				setModified(ifD);
				ifD.setRight(left);
			}
		}
	}
}