package edu.unu.iist.rcos.spec.antlr.visitor.transformation;

import static edu.unu.iist.rcos.spec.antlr.MyDesign.*;
import edu.unu.iist.rcos.spec.antlr.SyntaxTree.SyntaxTree_ClassModel.*;
import edu.unu.iist.rcos.spec.antlr.visitor.transformation.refinement.ExpRefinement;
import edu.unu.iist.rcos.spec.antlr.visitor.transformation.refinement.RefinementException;

/**
 * @author charles
 *
 */
public class ExpSimplification extends ExpRefinement<RefinementException> {

	@Override
	protected void visit(RELOP b) throws RefinementException {
		EXP new_left = run(b.getLeft());
		EXP new_right = run(b.getRight());
		setBINEXP(b, new_left, new_right);
	}
	
	@Override
	protected void visit(AOP b) throws RefinementException {
		EXP new_left = run(b.getLeft());
		EXP new_right = run(b.getRight());
		setBINEXP(b, new_left, new_right);
	}

	@Override
	protected void visit(LOGOP lop) throws RefinementException {
		EXP new_left = run(lop.getLeft());
		EXP new_right = run(lop.getRight());
		if (lop.getOp().equals(LogOps.AND)) {
			if (isTrue(new_left))
				setModified(new_right);
			else if (isTrue(new_right)) 
				setModified(new_left);
			else if (isFalse(new_left) || isFalse(new_right)) 
				setModified(createFalse());
			else 
				setBINEXP(lop,new_left,new_right);
		}  else if (lop.getOp().equals(LogOps.OR)) {
			if (isTrue(new_left) || isTrue(new_right)) 
				setModified(createTrue());
			else if (isFalse(new_right))
				setModified(new_left);
			else if (isFalse(new_left)) 
				setModified(new_right);
			else setBINEXP(lop,new_left,new_right);
		} else if (lop.getOp().equals(LogOps.IMP)) {
			if (isTrue(new_left))
				setModified(new_right);
			else
				setBINEXP(lop, new_left, new_right);
		} else
			setBINEXP(lop, new_left, new_right);
	}

	@Override
	protected void setBINEXP(BINEXP b, EXP left, EXP right) {
		super.setBINEXP(b, left, right);
		// XXX set modified
	}
}