package edu.unu.iist.rcos.spec.antlr.visitor.transformation;

import java.util.*;


import edu.unu.iist.rcos.spec.antlr.FreshNameGenerator;
import static edu.unu.iist.rcos.spec.antlr.MyDesign.*;
import edu.unu.iist.rcos.spec.antlr.SyntaxTree.SyntaxTree_ClassModel.*;

import edu.unu.iist.rcos.spec.antlr.visitor.transformation.refinement.ExpRefinement;
import edu.unu.iist.rcos.spec.antlr.visitor.transformation.refinement.RefinementException;

/**
 * @author charles
 *
 */
public class ExpSubstitutePredicate extends ExpRefinement<RefinementException> {

	final private Map<String, PREDICATE> l_var;
	
	public Map<String, PREDICATE> getListNewVariables() {
		return l_var;
	}
	
	public void reset() {
		l_var.clear();
	}
	
	private FreshNameGenerator fng;

	@Deprecated // TODO: the fng should be passed immediately
	public ExpSubstitutePredicate() {
		super();
		l_var = new HashMap<String, PREDICATE>();
	}

	public ExpSubstitutePredicate(FreshNameGenerator fng) {
		this();
		setFng(fng);
	}

	@Override
	protected void visit(PREDICATE p) {
		String name = fng.getBoolean();
		l_var.put(name, p);
		set(createVar(name, createBoolean()));
		return;
	}

	/**
	 * @param fng the fng to set
	 */
	public void setFng(FreshNameGenerator fng) {
		if (fng == null)
			throw new IllegalArgumentException();
		this.fng = fng;
	}

}
