package edu.unu.iist.rcos.spec.antlr.visitor.transformation.delegation;

import edu.unu.iist.rcos.spec.antlr.VardeclsFIS;
import edu.unu.iist.rcos.spec.antlr.SyntaxTree.SyntaxTree_ClassModel.*;
import edu.unu.iist.rcos.spec.antlr.visitor.DesignGenCopy;
import edu.unu.iist.rcos.spec.antlr.visitor.transformation.delegation.ExpDelegationVisitor.DelegationExceptionSoftFail;

public class DesignDelegationVisitor extends
		DesignGenCopy<DelegationException, ExpDelegationVisitor> {

	public DesignDelegationVisitor(REF tgt, VardeclsFIS vdcls, ArgTable inTable, ArgTable outTable) {
		super(new ExpDelegationVisitor(tgt, vdcls,inTable, outTable));
	}

	/**
	 * If we are delegating an assignment, we have to take care that the LHS gets passed
	 * around as an output parameter if necessary. Simply pretend it's dashed should do the trick :-) 
	 */
	@Override
	protected void visit(ASSIGN a) throws DelegationException {
		REF val = a.getVal();
		if (val instanceof DASHABLE)
			((DASHABLE) val).setDash(true);
		super.visit(a);
		ASSIGN na = (ASSIGN) state;
		if (na.getVal() instanceof DASHABLE)
			((DASHABLE) na.getVal()).setDash(false);
		if (na.getVal() instanceof THIS)
			throw new DelegationExceptionSoftFail("Result would assign to THIS.");
	}
}