package edu.unu.iist.rcos.spec.antlr.visitor.transformation.expert;

import org.eclipse.emf.common.command.*;
import org.eclipse.emf.edit.domain.EditingDomain;
import org.eclipse.uml2.uml.Classifier;

import edu.unu.iist.rcos.spec.antlr.SyntaxTree.SyntaxTree_ClassModel.CHOKE;
import edu.unu.iist.rcos.spec.antlr.SyntaxTree.SyntaxTree_ClassModel.MCALL;
import edu.unu.iist.rcos.spec.antlr.visitor.DesignVisitor;
import edu.unu.iist.rcos.spec.antlr.visitor.TypeVisitor;

public class DesignCreateGetter extends 
	DesignVisitor<CompoundCommand, CompoundCommand, Void, ExpertPatternException,TypeVisitor<Void, ExpertPatternException>, ExpCreateGetter> {
	
	public DesignCreateGetter(EditingDomain ed, Classifier cl) {
		// The inner visitor is only initialised once and will accumulate everything.
		super(new ExpCreateGetter(ed,cl));
	}
	
	@Override
	public CompoundCommand getResult() throws ExpertPatternException {
		return ev.getResult();
	}

	@Override
	protected void visit(MCALL m) throws ExpertPatternException {
		ev.getResult().append(new ExpCreateGetter(ev,true).run(m));
	}

	@Override
	protected void visit(CHOKE d) throws ExpertPatternException {
		throw new UnsupportedOperationException();
	}
}
