package edu.unu.iist.rcos.spec.antlr.visitor.transformation.refinement;

import static edu.unu.iist.rcos.spec.antlr.MyDesign.*;

import org.eclipse.uml2.uml.Classifier;
import edu.unu.iist.rcos.spec.antlr.SyntaxTree.SyntaxTree_ClassModel.*;
import edu.unu.iist.rcos.spec.antlr.visitor.check.GetTypeException;

/**
 * @author Charles Morisset
 * Transform [true |- foo()] into
 *    "if (foo()) then skip else magic" if foo() is of type boolean
 *    "foo()" otherwise
 */
public class DesignRefineMethods extends DesignRefinement<RefinementException, ExpRefinement<RefinementException>> {

	public DesignRefineMethods(Classifier cl) {
		super(new ExpRefinement<RefinementException>(), cl);
	}

	protected void visit(PP d) throws RefinementException { 
		if (isTrue(d.getPre()) && d.getPost() instanceof MCALL) {
			MCALL m = (MCALL) getCopy(d.getPost());
			try {
				if (gt.isBooleanExp(m)) {
					setModified(createIf(m, createSkip(), createMagic()));
				} else {
					// void type or not correctly typed
					setModified(m);
				}
			} catch (GetTypeException e) {
				throw new RefinementException(e);
			}
			return;
		} else {
			super.visit(d);
		}
	}
}
