package edu.unu.iist.rcos.spec.antlr.visitor.transformation.refinement;

import static edu.unu.iist.rcos.spec.antlr.MyDesign.*;

import org.eclipse.uml2.uml.Classifier;


import edu.unu.iist.rcos.spec.antlr.DesignUtility;
import edu.unu.iist.rcos.spec.antlr.MyDesign;
import edu.unu.iist.rcos.spec.antlr.SyntaxTree.SyntaxTree_ClassModel.*;

/**
 * @author charles
 * 
 * Rewrite every [true |- x' = e] and [true |- e = x'] into x:=e
 * Don't do anything otherwise
 * 
 */
public class DesignRelToAssign extends DesignRefinement<RefinementException, ExpRefinement<RefinementException>> {

	public DesignRelToAssign(Classifier c) {
		super(new ExpRefinement<RefinementException>(),c);
	}

	protected void visit(PP d) throws RefinementException { 
		ASSIGN a;
		if ((isTrue(d.getPre())) && ((a = getAssignFromExp(d.getPost())) != null)) {
			setModified(a);
			return;
		} else {
			super.visit(d);
		}
	}
	
	/**
	 * @author Charles Morisset
	 * @param r an expression x'=e or e=x'
	 * @return x:=e
	 */
	private ASSIGN getAssignFromExp(EXP r) {
		if (! (r instanceof RELOP)) return null;
		if (!( ((RELOP) r).getOp().equals(RelOps.EQ)) ) return null;
		
		RELOP rel = (RELOP) DesignUtility.copyExpression(r);
		
		if (rel.getLeft() instanceof REF && rel.getRight() instanceof EXP) {
			REF left = (REF) rel.getLeft();
			if (left instanceof DASHABLE && ((DASHABLE) left).isDash()) {
				((DASHABLE) left).setDash(false);
				return MyDesign.createAssign((REF) rel.getLeft(), (EXP) rel.getRight());
			} else {
				return null;
			}
		} else if (rel.getRight() instanceof REF && rel.getLeft() instanceof EXP) {
			REF right = (REF) rel.getRight();
			if (right instanceof DASHABLE && ((DASHABLE) right).isDash()) {
				((DASHABLE) right).setDash(false);
				return MyDesign.createAssign((REF) rel.getRight(), (EXP) rel.getLeft());
			} else {
				return null;
			}
		} else {
			return null;
		}
	}
}
