package edu.unu.iist.rcos.spec.transformer;


import org.eclipse.emf.common.command.Command;
import org.eclipse.emf.edit.domain.EditingDomain;
import org.eclipse.uml2.uml.Classifier;


import edu.unu.iist.rcos.spec.antlr.SyntaxTree.SyntaxTree_ClassModel.DESIGN;
import edu.unu.iist.rcos.spec.antlr.visitor.VisitorException;

public abstract class DesignTransformer<VE extends VisitorException> {

	final protected EditingDomain domain;

	public DesignTransformer(EditingDomain ed) {
		if (ed == null)
			throw new IllegalArgumentException();
		domain = ed;
	}

	/**
	 * @param d DESIGN to inspect
	 * @param cl Context of the current design
	 * @return the command preparing the model
	 * @throws VE
	 */
	public abstract Command getRequired(DESIGN d, Classifier cl) throws VE;
	

	/**
	 * @param d DESIGN to inspect
	 * @param cl Context of the current design
	 * @return transformed design
	 * @throws VE
	 */
	public abstract DESIGN transform(DESIGN d, Classifier cl) throws VE;
	
}
