package edu.unu.iist.rcos.spec.transformer;

import org.eclipse.emf.common.command.Command;
import org.eclipse.emf.edit.domain.EditingDomain;
import org.eclipse.uml2.uml.Classifier;
import edu.unu.iist.rcos.spec.antlr.SyntaxTree.SyntaxTree_ClassModel.DESIGN;
import edu.unu.iist.rcos.spec.antlr.visitor.transformation.expert.DesignCreateGetter;
import edu.unu.iist.rcos.spec.antlr.visitor.transformation.expert.ExpertPatternException;
import edu.unu.iist.rcos.spec.antlr.visitor.transformation.refinement.DesignReplaceGetter;

public class DesignTransformerEPGetED extends DesignTransformer<ExpertPatternException> {

	public DesignTransformerEPGetED(EditingDomain ed) {
		super(ed);
	}

	/**
	 * Warning: this method has the side-effect to create new owned operations in different classes, not only cl
	 * @author Charles Morisset
	 * @param d a design 
	 * @param cl the class in which the design is defined
	 * @return a copy of the design where each path has been replace by the corresponding getter 
	 * See corresponding publications for more information.
	 * @throws ExpertPatternException
	 */
	@Override
	public DESIGN transform(DESIGN d, Classifier cl) throws ExpertPatternException{
		return new DesignReplaceGetter(cl).run(d);
	}

	/**
	 * @author Charles Morisset
	 * @param d
	 * @param cl
	 * @return the command creating all the getters
	 * @throws ExpertPatternException
	 */
	@Override
	public Command getRequired(DESIGN d, Classifier cl)	throws ExpertPatternException {
		// We get all the command modifying the model, by creating the getters
		return new DesignCreateGetter(domain, cl).run(d);
	}
}
