package edu.unu.iist.rcos.spec.transformer;

import org.eclipse.emf.common.command.Command;
import org.eclipse.emf.edit.domain.EditingDomain;
import org.eclipse.uml2.uml.Classifier;
import edu.unu.iist.rcos.spec.antlr.SyntaxTree.SyntaxTree_ClassModel.DESIGN;
import edu.unu.iist.rcos.spec.antlr.visitor.VisitorException;
import edu.unu.iist.rcos.spec.antlr.visitor.transformation.expert.DesignCreateSetter;
import edu.unu.iist.rcos.spec.antlr.visitor.transformation.expert.ExpertPatternException;
import edu.unu.iist.rcos.spec.antlr.visitor.transformation.refinement.DesignReplaceSetter;

public class DesignTransformerEPSetED extends DesignTransformer<ExpertPatternException> {	

	public DesignTransformerEPSetED(EditingDomain ed) {
		super(ed);
	}

	/**
	 * Warning: this method has the side-effect to create new owned operations in different classes, not only cl
	 * @author Charles Morisset
	 * @param d a design 
	 * @param cl the class in which the design is defined
	 * @return a copy of the design where the "set" expert-pattern rule has been applied. See corresponding publications for more information.
	 * @throws VisitorException
	 */
	@Override
	public DESIGN transform(DESIGN d, Classifier cl) throws ExpertPatternException{
		return new DesignReplaceSetter(cl).run(d);
	}

	/**
	 * @author Charles Morisset
	 * @param d
	 * @param cl
	 * @return
	 * @throws ExpertPatternException
	 */
	@Override
	public Command getRequired(DESIGN d, Classifier cl)	throws ExpertPatternException {
		// We get all the command modifying the model, by creating the getters
		return new DesignCreateSetter(domain, cl).run(d);
	}
}
