package edu.unu.iist.rcos.spec.transformer;

import org.eclipse.emf.common.command.Command;
import org.eclipse.emf.common.command.IdentityCommand;
import org.eclipse.emf.edit.domain.EditingDomain;
import org.eclipse.uml2.uml.Classifier;

import edu.unu.iist.rcos.spec.antlr.DesignUtility;
import edu.unu.iist.rcos.spec.antlr.SyntaxTree.SyntaxTree_ClassModel.DESIGN;
import edu.unu.iist.rcos.spec.antlr.visitor.VisitorException;
import edu.unu.iist.rcos.spec.antlr.visitor.transformation.refinement.RefinementException;

public class DesignTransformerRewrite extends DesignTransformer<VisitorException> {

	public DesignTransformerRewrite(EditingDomain ed) {
		super(ed);
	}

	/**
	 * Warning: this method has the side-effect to create new owned operations in different classes, not only cl
	 * @author Charles Morisset
	 * @param d a design 
	 * @param cl the class in which the design is defined
	 * @return a copy of the design where the "get" expert-pattern rule has been applied. See corresponding publications for more information.
	 * @throws Exception 
	 */
	@Override
	public DESIGN transform(DESIGN d, Classifier cl) throws RefinementException{
		return DesignUtility.refine(d, cl);
	}

	/**
	 * @author Charles Morisset
	 * @param d
	 * @param cl
	 * @return
	 * @throws VisitorException
	 */
	@Override
	public Command getRequired(DESIGN d, Classifier cl)	throws VisitorException {
		return IdentityCommand.INSTANCE;
	}
	
	
}
